/* deletable.c generated by valac 0.40.19, the Vala compiler
 * generated from deletable.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004,2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>


#define SEAHORSE_TYPE_DELETABLE (seahorse_deletable_get_type ())
#define SEAHORSE_DELETABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_DELETABLE, SeahorseDeletable))
#define SEAHORSE_IS_DELETABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_DELETABLE))
#define SEAHORSE_DELETABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), SEAHORSE_TYPE_DELETABLE, SeahorseDeletableIface))

typedef struct _SeahorseDeletable SeahorseDeletable;
typedef struct _SeahorseDeletableIface SeahorseDeletableIface;

#define SEAHORSE_TYPE_DELETER (seahorse_deleter_get_type ())
#define SEAHORSE_DELETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_DELETER, SeahorseDeleter))
#define SEAHORSE_DELETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_DELETER, SeahorseDeleterClass))
#define SEAHORSE_IS_DELETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_DELETER))
#define SEAHORSE_IS_DELETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_DELETER))
#define SEAHORSE_DELETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_DELETER, SeahorseDeleterClass))

typedef struct _SeahorseDeleter SeahorseDeleter;
typedef struct _SeahorseDeleterClass SeahorseDeleterClass;
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _SeahorseDeletableIface {
	GTypeInterface parent_iface;
	SeahorseDeleter* (*create_deleter) (SeahorseDeletable* self);
	gboolean (*get_deletable) (SeahorseDeletable* self);
};

struct _Block1Data {
	int _ref_count_;
	GMainLoop* loop;
	GAsyncResult* _result_;
};



GType seahorse_deleter_get_type (void) G_GNUC_CONST;
GType seahorse_deletable_get_type (void) G_GNUC_CONST;
SeahorseDeleter* seahorse_deletable_create_deleter (SeahorseDeletable* self);
gboolean seahorse_deletable_can_delete (GObject* obj);
gboolean seahorse_deletable_get_deletable (SeahorseDeletable* self);
gint seahorse_deletable_delete_with_prompt_wait (GList* objects,
                                                 GtkWindow* parent,
                                                 GError** error);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
gboolean seahorse_deleter_add_object (SeahorseDeleter* self,
                                      GObject* obj);
gboolean seahorse_deleter_prompt (SeahorseDeleter* self,
                                  GtkWindow* parent);
void seahorse_deleter_delete (SeahorseDeleter* self,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
gboolean seahorse_deleter_delete_finish (SeahorseDeleter* self,
                                         GAsyncResult* _res_,
                                         GError** error);
static void ____lambda8_ (Block1Data* _data1_,
                   GObject* obj,
                   GAsyncResult* res);
static void _____lambda8__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
GList* seahorse_deleter_get_objects (SeahorseDeleter* self);


SeahorseDeleter*
seahorse_deletable_create_deleter (SeahorseDeletable* self)
{
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	return SEAHORSE_DELETABLE_GET_INTERFACE (self)->create_deleter (self);
#line 105 "deletable.c"
}


gboolean
seahorse_deletable_can_delete (GObject* obj)
{
	gboolean result = FALSE;
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	g_return_val_if_fail (obj != NULL, FALSE);
#line 28 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	if (SEAHORSE_IS_DELETABLE (obj)) {
#line 117 "deletable.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		_tmp0_ = seahorse_deletable_get_deletable (G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_DELETABLE, SeahorseDeletable));
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		_tmp1_ = _tmp0_;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		result = _tmp1_;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		return result;
#line 128 "deletable.c"
	}
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	result = FALSE;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	return result;
#line 134 "deletable.c"
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	return _data1_;
#line 145 "deletable.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		_g_object_unref0 (_data1_->_result_);
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		_g_main_loop_unref0 (_data1_->loop);
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		g_slice_free (Block1Data, _data1_);
#line 162 "deletable.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	return self ? g_object_ref (self) : NULL;
#line 172 "deletable.c"
}


static void
____lambda8_ (Block1Data* _data1_,
              GObject* obj,
              GAsyncResult* res)
{
	GAsyncResult* _tmp0_;
	GMainLoop* _tmp1_;
#line 69 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	g_return_if_fail (res != NULL);
#line 70 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_tmp0_ = _g_object_ref0 (res);
#line 70 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_g_object_unref0 (_data1_->_result_);
#line 70 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_data1_->_result_ = _tmp0_;
#line 71 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_tmp1_ = _data1_->loop;
#line 71 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	g_main_loop_quit (_tmp1_);
#line 195 "deletable.c"
}


static void
_____lambda8__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 69 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	____lambda8_ (self, source_object, res);
#line 69 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	block1_data_unref (self);
#line 208 "deletable.c"
}


gint
seahorse_deletable_delete_with_prompt_wait (GList* objects,
                                            GtkWindow* parent,
                                            GError** error)
{
	gint result = 0;
	Block1Data* _data1_;
	GMainLoop* _tmp0_;
	gint count = 0;
	GHashTable* pending = NULL;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_data1_->_ref_count_ = 1;
#line 36 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_tmp0_ = g_main_loop_new (NULL, FALSE);
#line 36 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_data1_->loop = _tmp0_;
#line 37 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_data1_->_result_ = NULL;
#line 38 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	count = 0;
#line 41 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_tmp1_ = g_direct_hash;
#line 41 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_tmp2_ = g_direct_equal;
#line 41 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, NULL, NULL);
#line 41 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	pending = _tmp3_;
#line 246 "deletable.c"
	{
		GList* obj_collection = NULL;
		GList* obj_it = NULL;
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		obj_collection = objects;
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		for (obj_it = obj_collection; obj_it != NULL; obj_it = obj_it->next) {
#line 254 "deletable.c"
			GObject* _tmp4_;
			GObject* obj = NULL;
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
			_tmp4_ = _g_object_ref0 ((GObject*) obj_it->data);
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
			obj = _tmp4_;
#line 261 "deletable.c"
			{
				GHashTable* _tmp5_;
				GObject* _tmp6_;
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp5_ = pending;
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp6_ = obj;
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				g_hash_table_add (_tmp5_, _tmp6_);
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_g_object_unref0 (obj);
#line 273 "deletable.c"
			}
		}
	}
	{
		GList* obj_collection = NULL;
		GList* obj_it = NULL;
#line 45 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		obj_collection = objects;
#line 45 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
		for (obj_it = obj_collection; obj_it != NULL; obj_it = obj_it->next) {
#line 284 "deletable.c"
			GObject* _tmp7_;
			GObject* obj = NULL;
#line 45 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
			_tmp7_ = _g_object_ref0 ((GObject*) obj_it->data);
#line 45 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
			obj = _tmp7_;
#line 291 "deletable.c"
			{
				GHashTable* _tmp8_;
				GObject* _tmp9_;
				GObject* _tmp10_;
				SeahorseDeleter* deleter = NULL;
				GObject* _tmp13_;
				SeahorseDeleter* _tmp14_;
				gboolean ret = FALSE;
				SeahorseDeleter* _tmp22_;
				gboolean _tmp23_;
				SeahorseDeleter* _tmp24_;
				GMainLoop* _tmp25_;
				gboolean _tmp26_ = FALSE;
				SeahorseDeleter* _tmp27_;
				GAsyncResult* _tmp28_;
#line 46 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp8_ = pending;
#line 46 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp9_ = obj;
#line 46 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				if (!g_hash_table_contains (_tmp8_, _tmp9_)) {
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_g_object_unref0 (obj);
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					continue;
#line 317 "deletable.c"
				}
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp10_ = obj;
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				if (!seahorse_deletable_can_delete (_tmp10_)) {
#line 323 "deletable.c"
					GHashTable* _tmp11_;
					GObject* _tmp12_;
#line 50 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_tmp11_ = pending;
#line 50 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_tmp12_ = obj;
#line 50 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					g_hash_table_remove (_tmp11_, _tmp12_);
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_g_object_unref0 (obj);
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					continue;
#line 336 "deletable.c"
				}
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp13_ = obj;
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp14_ = seahorse_deletable_create_deleter (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, SEAHORSE_TYPE_DELETABLE, SeahorseDeletable));
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				deleter = _tmp14_;
#line 344 "deletable.c"
				{
					GList* x_collection = NULL;
					GList* x_it = NULL;
#line 57 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					x_collection = objects;
#line 57 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					for (x_it = x_collection; x_it != NULL; x_it = x_it->next) {
#line 352 "deletable.c"
						GObject* _tmp15_;
						GObject* x = NULL;
#line 57 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
						_tmp15_ = _g_object_ref0 ((GObject*) x_it->data);
#line 57 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
						x = _tmp15_;
#line 359 "deletable.c"
						{
							GObject* _tmp16_;
							GObject* _tmp17_;
							GHashTable* _tmp18_;
							GObject* _tmp19_;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
							_tmp16_ = x;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
							_tmp17_ = obj;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
							if (_tmp16_ == _tmp17_) {
#line 59 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								_g_object_unref0 (x);
#line 59 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								continue;
#line 375 "deletable.c"
							}
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
							_tmp18_ = pending;
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
							_tmp19_ = x;
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
							if (g_hash_table_contains (_tmp18_, _tmp19_)) {
#line 383 "deletable.c"
								SeahorseDeleter* _tmp20_;
								GObject* _tmp21_;
#line 61 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								_tmp20_ = deleter;
#line 61 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								_tmp21_ = x;
#line 61 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								seahorse_deleter_add_object (_tmp20_, _tmp21_);
#line 392 "deletable.c"
							}
#line 57 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
							_g_object_unref0 (x);
#line 396 "deletable.c"
						}
					}
				}
#line 65 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp22_ = deleter;
#line 65 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				ret = seahorse_deleter_prompt (_tmp22_, parent);
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp23_ = ret;
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				if (!_tmp23_) {
#line 67 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_g_object_unref0 (deleter);
#line 67 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_g_object_unref0 (obj);
#line 67 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					break;
#line 414 "deletable.c"
				}
#line 69 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp24_ = deleter;
#line 69 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				seahorse_deleter_delete (_tmp24_, NULL, _____lambda8__gasync_ready_callback, block1_data_ref (_data1_));
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp25_ = _data1_->loop;
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				g_main_loop_run (_tmp25_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp27_ = deleter;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp28_ = _data1_->_result_;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_tmp26_ = seahorse_deleter_delete_finish (_tmp27_, _tmp28_, &_inner_error0_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 432 "deletable.c"
					gint _tmp29_ = -1;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					g_propagate_error (error, _inner_error0_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_g_object_unref0 (deleter);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_g_object_unref0 (obj);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_g_hash_table_unref0 (pending);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					block1_data_unref (_data1_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_data1_ = NULL;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					return _tmp29_;
#line 448 "deletable.c"
				}
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				if (_tmp26_) {
#line 452 "deletable.c"
					SeahorseDeleter* _tmp30_;
					GList* _tmp31_;
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_tmp30_ = deleter;
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_tmp31_ = seahorse_deleter_get_objects (_tmp30_);
#line 459 "deletable.c"
					{
						GList* x_collection = NULL;
						GList* x_it = NULL;
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
						x_collection = _tmp31_;
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
						for (x_it = x_collection; x_it != NULL; x_it = x_it->next) {
#line 467 "deletable.c"
							GObject* _tmp32_;
							GObject* x = NULL;
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
							_tmp32_ = _g_object_ref0 ((GObject*) x_it->data);
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
							x = _tmp32_;
#line 474 "deletable.c"
							{
								GHashTable* _tmp33_;
								GObject* _tmp34_;
								gint _tmp35_;
#line 78 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								_tmp33_ = pending;
#line 78 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								_tmp34_ = x;
#line 78 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								g_hash_table_remove (_tmp33_, _tmp34_);
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								_tmp35_ = count;
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								count = _tmp35_ + 1;
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
								_g_object_unref0 (x);
#line 491 "deletable.c"
							}
						}
					}
				} else {
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_g_object_unref0 (deleter);
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					_g_object_unref0 (obj);
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
					break;
#line 502 "deletable.c"
				}
#line 45 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_g_object_unref0 (deleter);
#line 45 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
				_g_object_unref0 (obj);
#line 508 "deletable.c"
			}
		}
	}
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	result = count;
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_g_hash_table_unref0 (pending);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	block1_data_unref (_data1_);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	_data1_ = NULL;
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	return result;
#line 522 "deletable.c"
}


gboolean
seahorse_deletable_get_deletable (SeahorseDeletable* self)
{
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	return SEAHORSE_DELETABLE_GET_INTERFACE (self)->get_deletable (self);
#line 533 "deletable.c"
}


static void
seahorse_deletable_default_init (SeahorseDeletableIface * iface)
{
#line 23 "/builddir/build/BUILD/seahorse-3.32.2/common/deletable.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("deletable", "deletable", "deletable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 542 "deletable.c"
}


GType
seahorse_deletable_get_type (void)
{
	static volatile gsize seahorse_deletable_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_deletable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseDeletableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_deletable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType seahorse_deletable_type_id;
		seahorse_deletable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SeahorseDeletable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (seahorse_deletable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&seahorse_deletable_type_id__volatile, seahorse_deletable_type_id);
	}
	return seahorse_deletable_type_id__volatile;
}



