/* predicate.c generated by valac 0.40.19, the Vala compiler
 * generated from predicate.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <string.h>

typedef gboolean (*SeahorsePredicateFunc) (GObject* obj, void* custom_target);

#define SEAHORSE_TYPE_PREDICATE (seahorse_predicate_get_type ())
typedef struct _SeahorsePredicate SeahorsePredicate;
typedef enum  {
	SEAHORSE_USAGE_NONE = 0,
	SEAHORSE_USAGE_SYMMETRIC_KEY = 1,
	SEAHORSE_USAGE_PUBLIC_KEY = 2,
	SEAHORSE_USAGE_PRIVATE_KEY = 3,
	SEAHORSE_USAGE_CREDENTIALS = 4,
	SEAHORSE_USAGE_IDENTITY = 5,
	SEAHORSE_USAGE_OTHER = 10
} SeahorseUsage;


#define SEAHORSE_TYPE_USAGE (seahorse_usage_get_type ())
typedef enum  {
	SEAHORSE_FLAG_NONE = 0,
	SEAHORSE_FLAG_IS_VALID = 0x00000001,
	SEAHORSE_FLAG_CAN_ENCRYPT = 0x00000002,
	SEAHORSE_FLAG_CAN_SIGN = 0x00000004,
	SEAHORSE_FLAG_CAN_CERTIFY = 0x00000008,
	SEAHORSE_FLAG_CAN_AUTHENTICATE = 0x00000010,
	SEAHORSE_FLAG_EXPIRED = 0x00000100,
	SEAHORSE_FLAG_REVOKED = 0x00000200,
	SEAHORSE_FLAG_DISABLED = 0x00000400,
	SEAHORSE_FLAG_TRUSTED = 0x00001000,
	SEAHORSE_FLAG_PERSONAL = 0x00002000,
	SEAHORSE_FLAG_EXPORTABLE = 0x00100000,
	SEAHORSE_FLAG_DELETABLE = 0x10000000
} SeahorseFlags;


#define SEAHORSE_TYPE_FLAGS (seahorse_flags_get_type ())

struct _SeahorsePredicate {
	GType type;
	SeahorseUsage usage;
	SeahorseFlags flags;
	SeahorseFlags nflags;
	SeahorsePredicateFunc custom;
	void* custom_target;
};



GType seahorse_predicate_get_type (void) G_GNUC_CONST;
GType seahorse_usage_get_type (void) G_GNUC_CONST;
GType seahorse_flags_get_type (void) G_GNUC_CONST;
SeahorsePredicate* seahorse_predicate_dup (const SeahorsePredicate* self);
void seahorse_predicate_free (SeahorsePredicate* self);
gboolean seahorse_predicate_match (SeahorsePredicate *self,
                                   GObject* obj);


/**
     * Matches a seahorse object and a predicate
     *
     * @param obj The predicate to match
     *
     * @return false if predicate does not match the Object, true else
     */
gboolean
seahorse_predicate_match (SeahorsePredicate *self,
                          GObject* obj)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GType _tmp1_;
	SeahorseUsage _tmp5_;
	gboolean _tmp9_ = FALSE;
	SeahorseFlags _tmp10_;
	gboolean _tmp21_ = FALSE;
	SeahorsePredicateFunc _tmp22_;
#line 41 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	g_return_val_if_fail (obj != NULL, FALSE);
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	_tmp1_ = (*self).type;
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	if (_tmp1_ != ((GType) 0)) {
#line 112 "predicate.c"
		gboolean _tmp2_ = FALSE;
		GType _tmp3_;
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp3_ = (*self).type;
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		if (g_type_is_a (G_TYPE_FROM_INSTANCE (obj), _tmp3_)) {
#line 119 "predicate.c"
			GType _tmp4_;
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp4_ = (*self).type;
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp2_ = g_type_is_a (_tmp4_, G_TYPE_FROM_INSTANCE (obj));
#line 125 "predicate.c"
		} else {
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp2_ = FALSE;
#line 129 "predicate.c"
		}
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp0_ = !_tmp2_;
#line 133 "predicate.c"
	} else {
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp0_ = FALSE;
#line 137 "predicate.c"
	}
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	if (_tmp0_) {
#line 44 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		result = FALSE;
#line 44 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		return result;
#line 145 "predicate.c"
	}
#line 46 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	_tmp5_ = (*self).usage;
#line 46 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	if (_tmp5_ != SEAHORSE_USAGE_NONE) {
#line 151 "predicate.c"
		SeahorseUsage obj_usage = 0;
		SeahorseUsage _tmp6_ = 0;
		SeahorseUsage _tmp7_;
		SeahorseUsage _tmp8_;
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		obj_usage = SEAHORSE_USAGE_NONE;
#line 48 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		g_object_get (obj, "usage", &_tmp6_, NULL, NULL);
#line 48 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		obj_usage = _tmp6_;
#line 50 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp7_ = (*self).usage;
#line 50 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp8_ = obj_usage;
#line 50 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		if (_tmp7_ != _tmp8_) {
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			result = FALSE;
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			return result;
#line 172 "predicate.c"
		}
	}
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	_tmp10_ = (*self).flags;
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	if (_tmp10_ != 0) {
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp9_ = TRUE;
#line 181 "predicate.c"
	} else {
		SeahorseFlags _tmp11_;
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp11_ = (*self).nflags;
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp9_ = _tmp11_ != 0;
#line 188 "predicate.c"
	}
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	if (_tmp9_) {
#line 192 "predicate.c"
		SeahorseFlags obj_flags = 0U;
		SeahorseFlags _tmp12_ = 0U;
		gboolean _tmp13_ = FALSE;
		SeahorseFlags _tmp14_;
		gboolean _tmp17_ = FALSE;
		SeahorseFlags _tmp18_;
#line 55 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		obj_flags = SEAHORSE_FLAG_NONE;
#line 56 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		g_object_get (obj, "object-flags", &_tmp12_, NULL, NULL);
#line 56 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		obj_flags = _tmp12_;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp14_ = (*self).flags;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		if (_tmp14_ != SEAHORSE_FLAG_NONE) {
#line 209 "predicate.c"
			SeahorseFlags _tmp15_;
			SeahorseFlags _tmp16_;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp15_ = obj_flags;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp16_ = (*self).flags;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp13_ = (_tmp16_ & _tmp15_) == _tmp15_;
#line 218 "predicate.c"
		} else {
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp13_ = FALSE;
#line 222 "predicate.c"
		}
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		if (_tmp13_) {
#line 59 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			result = FALSE;
#line 59 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			return result;
#line 230 "predicate.c"
		}
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp18_ = (*self).nflags;
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		if (_tmp18_ != SEAHORSE_FLAG_NONE) {
#line 236 "predicate.c"
			SeahorseFlags _tmp19_;
			SeahorseFlags _tmp20_;
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp19_ = obj_flags;
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp20_ = (*self).nflags;
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp17_ = !((_tmp20_ & _tmp19_) == _tmp19_);
#line 245 "predicate.c"
		} else {
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			_tmp17_ = FALSE;
#line 249 "predicate.c"
		}
#line 60 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		if (_tmp17_) {
#line 61 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			result = FALSE;
#line 61 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
			return result;
#line 257 "predicate.c"
		}
	}
#line 65 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	_tmp22_ = (*self).custom;
#line 65 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	if (_tmp22_ != NULL) {
#line 264 "predicate.c"
		SeahorsePredicateFunc _tmp23_;
		void* _tmp24_;
#line 65 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp23_ = (*self).custom;
#line 65 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp24_ = (*self).custom_target;
#line 65 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp21_ = !_tmp23_ (obj, _tmp24_);
#line 273 "predicate.c"
	} else {
#line 65 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		_tmp21_ = FALSE;
#line 277 "predicate.c"
	}
#line 65 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	if (_tmp21_) {
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		result = FALSE;
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
		return result;
#line 285 "predicate.c"
	}
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	result = TRUE;
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	return result;
#line 291 "predicate.c"
}


SeahorsePredicate*
seahorse_predicate_dup (const SeahorsePredicate* self)
{
	SeahorsePredicate* dup;
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	dup = g_new0 (SeahorsePredicate, 1);
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	memcpy (dup, self, sizeof (SeahorsePredicate));
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	return dup;
#line 305 "predicate.c"
}


void
seahorse_predicate_free (SeahorsePredicate* self)
{
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/common/predicate.vala"
	g_free (self);
#line 314 "predicate.c"
}


GType
seahorse_predicate_get_type (void)
{
	static volatile gsize seahorse_predicate_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_predicate_type_id__volatile)) {
		GType seahorse_predicate_type_id;
		seahorse_predicate_type_id = g_boxed_type_register_static ("SeahorsePredicate", (GBoxedCopyFunc) seahorse_predicate_dup, (GBoxedFreeFunc) seahorse_predicate_free);
		g_once_init_leave (&seahorse_predicate_type_id__volatile, seahorse_predicate_type_id);
	}
	return seahorse_predicate_type_id__volatile;
}



