/* pkcs11-request.c generated by valac 0.40.19, the Vala compiler
 * generated from pkcs11-request.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2013 Red Hat Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * Stef Walter <stefw@redhat.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gck/gck.h>
#include <stdlib.h>
#include <string.h>
#include <gcr/gcr-base.h>
#include "seahorse-common.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define SEAHORSE_PKCS11_TYPE_REQUEST (seahorse_pkcs11_request_get_type ())
#define SEAHORSE_PKCS11_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_PKCS11_TYPE_REQUEST, SeahorsePkcs11Request))
#define SEAHORSE_PKCS11_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_PKCS11_TYPE_REQUEST, SeahorsePkcs11RequestClass))
#define SEAHORSE_PKCS11_IS_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_PKCS11_TYPE_REQUEST))
#define SEAHORSE_PKCS11_IS_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_PKCS11_TYPE_REQUEST))
#define SEAHORSE_PKCS11_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_PKCS11_TYPE_REQUEST, SeahorsePkcs11RequestClass))

typedef struct _SeahorsePkcs11Request SeahorsePkcs11Request;
typedef struct _SeahorsePkcs11RequestClass SeahorsePkcs11RequestClass;
typedef struct _SeahorsePkcs11RequestPrivate SeahorsePkcs11RequestPrivate;

#define SEAHORSE_PKCS11_TYPE_PRIVATE_KEY (seahorse_pkcs11_private_key_get_type ())
#define SEAHORSE_PKCS11_PRIVATE_KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_PKCS11_TYPE_PRIVATE_KEY, SeahorsePkcs11PrivateKey))
#define SEAHORSE_PKCS11_PRIVATE_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_PKCS11_TYPE_PRIVATE_KEY, SeahorsePkcs11PrivateKeyClass))
#define SEAHORSE_PKCS11_IS_PRIVATE_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_PKCS11_TYPE_PRIVATE_KEY))
#define SEAHORSE_PKCS11_IS_PRIVATE_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_PKCS11_TYPE_PRIVATE_KEY))
#define SEAHORSE_PKCS11_PRIVATE_KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_PKCS11_TYPE_PRIVATE_KEY, SeahorsePkcs11PrivateKeyClass))

typedef struct _SeahorsePkcs11PrivateKey SeahorsePkcs11PrivateKey;
typedef struct _SeahorsePkcs11PrivateKeyClass SeahorsePkcs11PrivateKeyClass;
enum  {
	SEAHORSE_PKCS11_REQUEST_0_PROPERTY,
	SEAHORSE_PKCS11_REQUEST_PRIVATE_KEY_PROPERTY,
	SEAHORSE_PKCS11_REQUEST_NUM_PROPERTIES
};
static GParamSpec* seahorse_pkcs11_request_properties[SEAHORSE_PKCS11_REQUEST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;

struct _SeahorsePkcs11Request {
	GtkDialog parent_instance;
	SeahorsePkcs11RequestPrivate * priv;
};

struct _SeahorsePkcs11RequestClass {
	GtkDialogClass parent_class;
};

struct _SeahorsePkcs11RequestPrivate {
	SeahorsePkcs11PrivateKey* _private_key;
	GtkEntry* _name_entry;
	guint8* _encoded;
	gint _encoded_length1;
	gint __encoded_size_;
};

struct _Block3Data {
	int _ref_count_;
	SeahorsePkcs11Request* self;
	GcrCertificateRequest* req;
};

struct _Block4Data {
	int _ref_count_;
	SeahorsePkcs11Request* self;
	GtkWindow* parent;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GFile* file;
};


static gpointer seahorse_pkcs11_request_parent_class = NULL;
static gchar* seahorse_pkcs11_request_BAD_FILENAME_CHARS;
static gchar* seahorse_pkcs11_request_BAD_FILENAME_CHARS = NULL;

GType seahorse_pkcs11_request_get_type (void) G_GNUC_CONST;
GType seahorse_pkcs11_private_key_get_type (void) G_GNUC_CONST;
#define SEAHORSE_PKCS11_REQUEST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SEAHORSE_PKCS11_TYPE_REQUEST, SeahorsePkcs11RequestPrivate))
void seahorse_pkcs11_request_prompt (GtkWindow* parent,
                                     GckObject* private_key);
static void seahorse_pkcs11_request_real_response (GtkDialog* base,
                                            gint response_id);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
SeahorsePkcs11PrivateKey* seahorse_pkcs11_request_get_private_key (SeahorsePkcs11Request* self);
static void ___lambda5_ (Block3Data* _data3_,
                  GObject* obj,
                  GAsyncResult* res);
static void seahorse_pkcs11_request_save_certificate_request (SeahorsePkcs11Request* self,
                                                       GcrCertificateRequest* req,
                                                       GtkWindow* parent);
static void ____lambda5__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void seahorse_pkcs11_request_update_response (SeahorsePkcs11Request* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda6_ (Block5Data* _data5_,
                  GObject* obj,
                  GAsyncResult* res);
static void ____lambda6__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
SeahorsePkcs11Request* seahorse_pkcs11_request_new (void);
SeahorsePkcs11Request* seahorse_pkcs11_request_construct (GType object_type);
static void seahorse_pkcs11_request_set_private_key (SeahorsePkcs11Request* self,
                                              SeahorsePkcs11PrivateKey* value);
static GObject * seahorse_pkcs11_request_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _seahorse_pkcs11_request___lambda7_ (SeahorsePkcs11Request* self);
static void __seahorse_pkcs11_request___lambda7__gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self);
static void seahorse_pkcs11_request_finalize (GObject * obj);
static void _vala_seahorse_pkcs11_request_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_seahorse_pkcs11_request_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);


void
seahorse_pkcs11_request_prompt (GtkWindow* parent,
                                GckObject* private_key)
{
	SeahorsePkcs11Request* dialog = NULL;
	GObject* _tmp0_;
	GObject* _tmp1_;
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_return_if_fail (private_key != NULL);
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp0_ = g_object_new (SEAHORSE_PKCS11_TYPE_REQUEST, "transient-for", parent, "private-key", private_key, NULL);
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	dialog = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, SEAHORSE_PKCS11_TYPE_REQUEST, SeahorsePkcs11Request);
#line 70 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_dialog_run ((GtkDialog*) dialog);
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (dialog);
#line 186 "pkcs11-request.c"
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	return _data3_;
#line 197 "pkcs11-request.c"
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 208 "pkcs11-request.c"
		SeahorsePkcs11Request* self;
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		self = _data3_->self;
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (_data3_->req);
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (self);
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_slice_free (Block3Data, _data3_);
#line 218 "pkcs11-request.c"
	}
}


static void
___lambda5_ (Block3Data* _data3_,
             GObject* obj,
             GAsyncResult* res)
{
	SeahorsePkcs11Request* self;
	GError* _inner_error0_ = NULL;
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	self = _data3_->self;
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_return_if_fail (res != NULL);
#line 234 "pkcs11-request.c"
	{
		GcrCertificateRequest* _tmp0_;
		GcrCertificateRequest* _tmp1_;
		GtkWindow* _tmp2_;
		GtkWindow* _tmp3_;
#line 84 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp0_ = _data3_->req;
#line 84 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		gcr_certificate_request_complete_finish (_tmp0_, res, &_inner_error0_);
#line 84 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "pkcs11-request.c"
			goto __catch6_g_error;
		}
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp1_ = _data3_->req;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp2_ = gtk_window_get_transient_for ((GtkWindow*) self);
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp3_ = _tmp2_;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		seahorse_pkcs11_request_save_certificate_request (self, _tmp1_, _tmp3_);
#line 257 "pkcs11-request.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* err = NULL;
		GtkWindow* _tmp4_;
		GtkWindow* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 83 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		err = _inner_error0_;
#line 83 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_inner_error0_ = NULL;
#line 87 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp4_ = gtk_window_get_transient_for ((GtkWindow*) self);
#line 87 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp5_ = _tmp4_;
#line 87 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp6_ = err;
#line 87 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp7_ = _tmp6_->message;
#line 87 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		seahorse_util_show_error ((GtkWidget*) _tmp5_, _ ("Couldn’t create certificate request"), _tmp7_);
#line 83 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_error_free0 (err);
#line 283 "pkcs11-request.c"
	}
	__finally6:
#line 83 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 83 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_clear_error (&_inner_error0_);
#line 83 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		return;
#line 294 "pkcs11-request.c"
	}
}


static void
____lambda5__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	___lambda5_ (self, source_object, res);
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	block3_data_unref (self);
#line 308 "pkcs11-request.c"
}


static void
seahorse_pkcs11_request_real_response (GtkDialog* base,
                                       gint response_id)
{
	SeahorsePkcs11Request * self;
#line 73 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	self = (SeahorsePkcs11Request*) base;
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (response_id == ((gint) GTK_RESPONSE_OK)) {
#line 321 "pkcs11-request.c"
		Block3Data* _data3_;
		SeahorseInteraction* interaction = NULL;
		GtkWindow* _tmp0_;
		GtkWindow* _tmp1_;
		SeahorseInteraction* _tmp2_;
		GckSession* session = NULL;
		SeahorsePkcs11PrivateKey* _tmp3_;
		GckSession* _tmp4_;
		GckSession* _tmp5_;
		SeahorseInteraction* _tmp6_;
		SeahorsePkcs11PrivateKey* _tmp7_;
		GcrCertificateRequest* _tmp8_;
		GcrCertificateRequest* _tmp9_;
		GtkEntry* _tmp10_;
		const gchar* _tmp11_;
		GcrCertificateRequest* _tmp12_;
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data3_ = g_slice_new0 (Block3Data);
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data3_->_ref_count_ = 1;
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data3_->self = g_object_ref (self);
#line 75 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp0_ = gtk_window_get_transient_for ((GtkWindow*) self);
#line 75 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp1_ = _tmp0_;
#line 75 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp2_ = seahorse_interaction_new (_tmp1_);
#line 75 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		interaction = _tmp2_;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp3_ = self->priv->_private_key;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp4_ = gck_object_get_session ((GckObject*) _tmp3_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		session = _tmp4_;
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp5_ = session;
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp6_ = interaction;
#line 77 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		gck_session_set_interaction (_tmp5_, (GTlsInteraction*) _tmp6_);
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp7_ = self->priv->_private_key;
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp8_ = gcr_certificate_request_prepare (GCR_CERTIFICATE_REQUEST_PKCS10, (GckObject*) _tmp7_);
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data3_->req = _tmp8_;
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp9_ = _data3_->req;
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp10_ = self->priv->_name_entry;
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp11_ = gtk_entry_get_text (_tmp10_);
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		gcr_certificate_request_set_cn (_tmp9_, _tmp11_);
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp12_ = _data3_->req;
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		gcr_certificate_request_complete_async (_tmp12_, NULL, ____lambda5__gasync_ready_callback, block3_data_ref (_data3_));
#line 91 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (session);
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (interaction);
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		block3_data_unref (_data3_);
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data3_ = NULL;
#line 392 "pkcs11-request.c"
	}
}


static void
seahorse_pkcs11_request_update_response (SeahorsePkcs11Request* self)
{
	gchar* name = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 95 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_return_if_fail (self != NULL);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp0_ = self->priv->_name_entry;
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	name = _tmp2_;
#line 97 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_dialog_set_response_sensitive ((GtkDialog*) self, (gint) GTK_RESPONSE_OK, g_strcmp0 (name, "") != 0);
#line 95 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_free0 (name);
#line 418 "pkcs11-request.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	return self ? g_object_ref (self) : NULL;
#line 427 "pkcs11-request.c"
}


static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	return _data4_;
#line 438 "pkcs11-request.c"
}


static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 449 "pkcs11-request.c"
		SeahorsePkcs11Request* self;
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		self = _data4_->self;
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (_data4_->parent);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (self);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_slice_free (Block4Data, _data4_);
#line 459 "pkcs11-request.c"
	}
}


static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1312 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1312 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1313 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1313 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1314 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1314 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strdelimit (_tmp1_, delimiters, new_delimiter);
#line 1315 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1315 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 489 "pkcs11-request.c"
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	return _data5_;
#line 500 "pkcs11-request.c"
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 511 "pkcs11-request.c"
		SeahorsePkcs11Request* self;
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		self = _data5_->_data4_->self;
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (_data5_->file);
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		block4_data_unref (_data5_->_data4_);
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data5_->_data4_ = NULL;
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_slice_free (Block5Data, _data5_);
#line 523 "pkcs11-request.c"
	}
}


static void
___lambda6_ (Block5Data* _data5_,
             GObject* obj,
             GAsyncResult* res)
{
	Block4Data* _data4_;
	SeahorsePkcs11Request* self;
	GError* _inner_error0_ = NULL;
#line 144 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_data4_ = _data5_->_data4_;
#line 144 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	self = _data4_->self;
#line 144 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_return_if_fail (res != NULL);
#line 542 "pkcs11-request.c"
	{
		gchar* new_etag = NULL;
		GFile* _tmp0_;
		gchar* _tmp1_ = NULL;
#line 147 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp0_ = _data5_->file;
#line 147 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_file_replace_contents_finish (_tmp0_, res, &_tmp1_, &_inner_error0_);
#line 147 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_free0 (new_etag);
#line 147 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		new_etag = _tmp1_;
#line 147 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
			_g_free0 (new_etag);
#line 559 "pkcs11-request.c"
			goto __catch7_g_error;
		}
#line 145 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_free0 (new_etag);
#line 564 "pkcs11-request.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 145 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		err = _inner_error0_;
#line 145 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_inner_error0_ = NULL;
#line 149 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp2_ = err;
#line 149 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp3_ = _tmp2_->message;
#line 149 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		seahorse_util_show_error ((GtkWidget*) _data4_->parent, _ ("Couldn’t save certificate request"), _tmp3_);
#line 145 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_error_free0 (err);
#line 584 "pkcs11-request.c"
	}
	__finally7:
#line 145 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_clear_error (&_inner_error0_);
#line 145 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		return;
#line 595 "pkcs11-request.c"
	}
}


static void
____lambda6__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	___lambda6_ (self, source_object, res);
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	block5_data_unref (self);
#line 609 "pkcs11-request.c"
}


static void
seahorse_pkcs11_request_save_certificate_request (SeahorsePkcs11Request* self,
                                                  GcrCertificateRequest* req,
                                                  GtkWindow* parent)
{
	Block4Data* _data4_;
	GtkWindow* _tmp0_;
	GtkFileChooserDialog* chooser = NULL;
	GtkFileChooserDialog* _tmp1_;
	GtkFileChooserDialog* _tmp2_;
	GtkFileChooserDialog* _tmp3_;
	GtkFileFilter* der_filter = NULL;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileFilter* _tmp6_;
	GtkFileFilter* _tmp7_;
	GtkFileFilter* _tmp8_;
	GtkFileChooserDialog* _tmp9_;
	GtkFileFilter* _tmp10_;
	GtkFileFilter* _tmp11_;
	GtkFileChooserDialog* _tmp12_;
	GtkFileFilter* _tmp13_;
	GtkFileFilter* pem_filter = NULL;
	GtkFileFilter* _tmp14_;
	GtkFileFilter* _tmp15_;
	GtkFileFilter* _tmp16_;
	GtkFileFilter* _tmp17_;
	GtkFileChooserDialog* _tmp18_;
	GtkFileFilter* _tmp19_;
	GtkFileFilter* _tmp20_;
	gchar* label = NULL;
	SeahorsePkcs11PrivateKey* _tmp21_;
	gchar* _tmp22_ = NULL;
	gboolean _tmp23_ = FALSE;
	const gchar* _tmp24_;
	gchar* filename = NULL;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	GtkFileChooserDialog* _tmp32_;
	const gchar* _tmp33_;
	GtkFileChooserDialog* _tmp34_;
	gint response = 0;
	GtkFileChooserDialog* _tmp35_;
	gint _tmp36_;
	GtkFileChooserDialog* _tmp47_;
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_return_if_fail (self != NULL);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_return_if_fail (req != NULL);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_data4_->_ref_count_ = 1;
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_data4_->self = g_object_ref (self);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (_data4_->parent);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_data4_->parent = _tmp0_;
#line 104 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp1_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Save certificate request"), _data4_->parent, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("_Cancel"), GTK_RESPONSE_CANCEL, _ ("_Save"), GTK_RESPONSE_ACCEPT, NULL);
#line 104 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_object_ref_sink (_tmp1_);
#line 104 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	chooser = _tmp1_;
#line 109 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp2_ = chooser;
#line 109 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_dialog_set_default_response ((GtkDialog*) _tmp2_, (gint) GTK_RESPONSE_ACCEPT);
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp3_ = chooser;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp3_, FALSE);
#line 112 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp4_ = gtk_file_filter_new ();
#line 112 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_object_ref_sink (_tmp4_);
#line 112 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	der_filter = _tmp4_;
#line 113 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp5_ = der_filter;
#line 113 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_buildable_set_name ((GtkBuildable*) _tmp5_, _ ("Certificate request"));
#line 114 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp6_ = der_filter;
#line 114 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_filter_add_mime_type (_tmp6_, "application/pkcs10");
#line 115 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp7_ = der_filter;
#line 115 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_filter_add_pattern (_tmp7_, "*.p10");
#line 116 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp8_ = der_filter;
#line 116 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_filter_add_pattern (_tmp8_, "*.csr");
#line 117 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp9_ = chooser;
#line 117 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp10_ = der_filter;
#line 117 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 117 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp9_, _tmp11_);
#line 118 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp12_ = chooser;
#line 118 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp13_ = der_filter;
#line 118 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp12_, _tmp13_);
#line 120 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp14_ = gtk_file_filter_new ();
#line 120 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_object_ref_sink (_tmp14_);
#line 120 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	pem_filter = _tmp14_;
#line 121 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp15_ = pem_filter;
#line 121 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_buildable_set_name ((GtkBuildable*) _tmp15_, _ ("PEM encoded request"));
#line 122 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp16_ = pem_filter;
#line 122 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_filter_add_mime_type (_tmp16_, "application/pkcs10+pem");
#line 123 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp17_ = pem_filter;
#line 123 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_filter_add_pattern (_tmp17_, "*.pem");
#line 124 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp18_ = chooser;
#line 124 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp19_ = pem_filter;
#line 124 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp20_ = _g_object_ref0 (_tmp19_);
#line 124 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp18_, _tmp20_);
#line 127 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp21_ = self->priv->_private_key;
#line 127 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_object_get ((GObject*) _tmp21_, "label", &_tmp22_, NULL);
#line 127 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_free0 (label);
#line 127 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	label = _tmp22_;
#line 128 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp24_ = label;
#line 128 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (_tmp24_ == NULL) {
#line 128 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp23_ = TRUE;
#line 767 "pkcs11-request.c"
	} else {
		const gchar* _tmp25_;
#line 128 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp25_ = label;
#line 128 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp23_ = g_strcmp0 (_tmp25_, "") == 0;
#line 774 "pkcs11-request.c"
	}
#line 128 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (_tmp23_) {
#line 778 "pkcs11-request.c"
		gchar* _tmp26_;
#line 129 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp26_ = g_strdup ("Certificate Request");
#line 129 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_free0 (label);
#line 129 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		label = _tmp26_;
#line 786 "pkcs11-request.c"
	}
#line 130 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp27_ = label;
#line 130 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp28_ = g_strconcat (_tmp27_, ".csr", NULL);
#line 130 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	filename = _tmp28_;
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp29_ = filename;
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp30_ = seahorse_pkcs11_request_BAD_FILENAME_CHARS;
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp31_ = string_delimit (_tmp29_, _tmp30_, '_');
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_free0 (filename);
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	filename = _tmp31_;
#line 132 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp32_ = chooser;
#line 132 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp33_ = filename;
#line 132 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp32_, _tmp33_);
#line 134 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp34_ = chooser;
#line 134 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp34_, TRUE);
#line 136 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp35_ = chooser;
#line 136 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	response = gtk_dialog_run ((GtkDialog*) _tmp35_);
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp36_ = response;
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (_tmp36_ == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 822 "pkcs11-request.c"
		Block5Data* _data5_;
		gboolean textual = FALSE;
		GtkFileChooserDialog* _tmp37_;
		GtkFileFilter* _tmp38_;
		GtkFileFilter* _tmp39_;
		gboolean _tmp40_;
		gsize _tmp41_ = 0;
		guint8* _tmp42_;
		GtkFileChooserDialog* _tmp43_;
		GFile* _tmp44_;
		GFile* _tmp45_;
		guint8* _tmp46_;
		gint _tmp46__length1;
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data5_ = g_slice_new0 (Block5Data);
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data5_->_ref_count_ = 1;
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data5_->_data4_ = block4_data_ref (_data4_);
#line 138 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp37_ = chooser;
#line 138 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp38_ = gtk_file_chooser_get_filter ((GtkFileChooser*) _tmp37_);
#line 138 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp39_ = pem_filter;
#line 138 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		textual = _tmp38_ == _tmp39_;
#line 139 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp40_ = textual;
#line 139 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp42_ = gcr_certificate_request_encode (req, _tmp40_, &_tmp41_);
#line 139 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		self->priv->_encoded = (g_free (self->priv->_encoded), NULL);
#line 139 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		self->priv->_encoded = _tmp42_;
#line 139 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		self->priv->_encoded_length1 = _tmp41_;
#line 139 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		self->priv->__encoded_size_ = self->priv->_encoded_length1;
#line 141 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp43_ = chooser;
#line 141 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp44_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp43_);
#line 141 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data5_->file = _tmp44_;
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp45_ = _data5_->file;
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp46_ = self->priv->_encoded;
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp46__length1 = self->priv->_encoded_length1;
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_file_replace_contents_async (_tmp45_, _tmp46_, (gsize) _tmp46__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, ____lambda6__gasync_ready_callback, block5_data_ref (_data5_));
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		block5_data_unref (_data5_);
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_data5_ = NULL;
#line 880 "pkcs11-request.c"
	}
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp47_ = chooser;
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp47_);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_free0 (filename);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_free0 (label);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (pem_filter);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (der_filter);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (chooser);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	block4_data_unref (_data4_);
#line 102 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_data4_ = NULL;
#line 900 "pkcs11-request.c"
}


SeahorsePkcs11Request*
seahorse_pkcs11_request_construct (GType object_type)
{
	SeahorsePkcs11Request * self = NULL;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	self = (SeahorsePkcs11Request*) g_object_new (object_type, NULL);
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	return self;
#line 912 "pkcs11-request.c"
}


SeahorsePkcs11Request*
seahorse_pkcs11_request_new (void)
{
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	return seahorse_pkcs11_request_construct (SEAHORSE_PKCS11_TYPE_REQUEST);
#line 921 "pkcs11-request.c"
}


SeahorsePkcs11PrivateKey*
seahorse_pkcs11_request_get_private_key (SeahorsePkcs11Request* self)
{
	SeahorsePkcs11PrivateKey* result;
	SeahorsePkcs11PrivateKey* _tmp0_;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp0_ = self->priv->_private_key;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	return result;
#line 938 "pkcs11-request.c"
}


static void
seahorse_pkcs11_request_set_private_key (SeahorsePkcs11Request* self,
                                         SeahorsePkcs11PrivateKey* value)
{
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (seahorse_pkcs11_request_get_private_key (self) != value) {
#line 950 "pkcs11-request.c"
		SeahorsePkcs11PrivateKey* _tmp0_;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (self->priv->_private_key);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		self->priv->_private_key = _tmp0_;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_pkcs11_request_properties[SEAHORSE_PKCS11_REQUEST_PRIVATE_KEY_PROPERTY]);
#line 960 "pkcs11-request.c"
	}
}


static void
_seahorse_pkcs11_request___lambda7_ (SeahorsePkcs11Request* self)
{
#line 52 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	seahorse_pkcs11_request_update_response (self);
#line 970 "pkcs11-request.c"
}


static void
__seahorse_pkcs11_request___lambda7__gtk_editable_changed (GtkEditable* _sender,
                                                           gpointer self)
{
#line 52 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_seahorse_pkcs11_request___lambda7_ ((SeahorsePkcs11Request*) self);
#line 980 "pkcs11-request.c"
}


static GObject *
seahorse_pkcs11_request_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorsePkcs11Request * self;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	gchar* path = NULL;
	gchar* _tmp1_;
	GtkBox* content = NULL;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkWidget* widget = NULL;
	GtkBuilder* _tmp7_;
	GObject* _tmp8_;
	GtkWidget* _tmp9_;
	GtkBox* _tmp10_;
	GtkWidget* _tmp11_;
	GtkWidget* _tmp12_;
	GtkBuilder* _tmp13_;
	GObject* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	SeahorsePkcs11PrivateKey* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 35 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	parent_class = G_OBJECT_CLASS (seahorse_pkcs11_request_parent_class);
#line 35 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_TYPE_REQUEST, SeahorsePkcs11Request);
#line 36 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp0_ = gtk_builder_new ();
#line 36 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	builder = _tmp0_;
#line 37 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp1_ = g_strdup ("/org/gnome/Seahorse/seahorse-pkcs11-request.ui");
#line 37 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	path = _tmp1_;
#line 1026 "pkcs11-request.c"
	{
		GtkBuilder* _tmp2_;
		const gchar* _tmp3_;
#line 39 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp2_ = builder;
#line 39 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp3_ = path;
#line 39 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		gtk_builder_add_from_resource (_tmp2_, _tmp3_, &_inner_error0_);
#line 39 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1038 "pkcs11-request.c"
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp4_;
#line 38 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		err = _inner_error0_;
#line 38 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_inner_error0_ = NULL;
#line 41 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp4_ = path;
#line 41 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_warning ("pkcs11-request.vala:41: couldn't load ui file: %s", _tmp4_);
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_error_free0 (err);
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_free0 (path);
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (builder);
#line 42 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		return obj;
#line 1063 "pkcs11-request.c"
	}
	__finally8:
#line 38 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_free0 (path);
#line 38 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_g_object_unref0 (builder);
#line 38 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_clear_error (&_inner_error0_);
#line 1076 "pkcs11-request.c"
	}
#line 45 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 46 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp5_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 46 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 46 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	content = _tmp6_;
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp7_ = builder;
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp8_ = gtk_builder_get_object (_tmp7_, "pkcs11-request");
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	widget = _tmp9_;
#line 48 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp10_ = content;
#line 48 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp11_ = widget;
#line 48 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, _tmp11_);
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp12_ = widget;
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_widget_show (_tmp12_);
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp13_ = builder;
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp14_ = gtk_builder_get_object (_tmp13_, "request-name");
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_entry_get_type (), GtkEntry));
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (self->priv->_name_entry);
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	self->priv->_name_entry = _tmp15_;
#line 52 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp16_ = self->priv->_name_entry;
#line 52 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_signal_connect_object ((GtkEditable*) _tmp16_, "changed", (GCallback) __seahorse_pkcs11_request___lambda7__gtk_editable_changed, self, 0);
#line 55 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_dialog_add_buttons ((GtkDialog*) self, _ ("_Cancel"), GTK_RESPONSE_CANCEL, _ ("Create"), GTK_RESPONSE_OK, NULL);
#line 57 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	gtk_dialog_set_default_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
#line 59 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	seahorse_pkcs11_request_update_response (self);
#line 61 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp17_ = self->priv->_private_key;
#line 61 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, gck_object_get_type ())) {
#line 1128 "pkcs11-request.c"
		const gchar* _tmp18_;
#line 62 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		_tmp18_ = g_type_name (gck_object_get_type ());
#line 62 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_critical ("pkcs11-request.vala:62: private key is not of type %s", _tmp18_);
#line 1134 "pkcs11-request.c"
	}
#line 35 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (widget);
#line 35 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (content);
#line 35 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_free0 (path);
#line 35 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (builder);
#line 35 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	return obj;
#line 1146 "pkcs11-request.c"
}


static void
seahorse_pkcs11_request_class_init (SeahorsePkcs11RequestClass * klass)
{
	gchar* _tmp0_;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	seahorse_pkcs11_request_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_type_class_add_private (klass, sizeof (SeahorsePkcs11RequestPrivate));
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	((GtkDialogClass *) klass)->response = (void (*) (GtkDialog*, gint)) seahorse_pkcs11_request_real_response;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_pkcs11_request_get_property;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_pkcs11_request_set_property;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_pkcs11_request_constructor;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_pkcs11_request_finalize;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_REQUEST_PRIVATE_KEY_PROPERTY, seahorse_pkcs11_request_properties[SEAHORSE_PKCS11_REQUEST_PRIVATE_KEY_PROPERTY] = g_param_spec_object ("private-key", "private-key", "private-key", SEAHORSE_PKCS11_TYPE_PRIVATE_KEY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 100 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_tmp0_ = g_strdup ("/\\<>|?*");
#line 100 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	seahorse_pkcs11_request_BAD_FILENAME_CHARS = _tmp0_;
#line 1174 "pkcs11-request.c"
}


static void
seahorse_pkcs11_request_instance_init (SeahorsePkcs11Request * self)
{
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	self->priv = SEAHORSE_PKCS11_REQUEST_GET_PRIVATE (self);
#line 1183 "pkcs11-request.c"
}


static void
seahorse_pkcs11_request_finalize (GObject * obj)
{
	SeahorsePkcs11Request * self;
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_TYPE_REQUEST, SeahorsePkcs11Request);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (self->priv->_private_key);
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	_g_object_unref0 (self->priv->_name_entry);
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	self->priv->_encoded = (g_free (self->priv->_encoded), NULL);
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	G_OBJECT_CLASS (seahorse_pkcs11_request_parent_class)->finalize (obj);
#line 1201 "pkcs11-request.c"
}


GType
seahorse_pkcs11_request_get_type (void)
{
	static volatile gsize seahorse_pkcs11_request_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_pkcs11_request_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorsePkcs11RequestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_pkcs11_request_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePkcs11Request), 0, (GInstanceInitFunc) seahorse_pkcs11_request_instance_init, NULL };
		GType seahorse_pkcs11_request_type_id;
		seahorse_pkcs11_request_type_id = g_type_register_static (gtk_dialog_get_type (), "SeahorsePkcs11Request", &g_define_type_info, 0);
		g_once_init_leave (&seahorse_pkcs11_request_type_id__volatile, seahorse_pkcs11_request_type_id);
	}
	return seahorse_pkcs11_request_type_id__volatile;
}


static void
_vala_seahorse_pkcs11_request_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	SeahorsePkcs11Request * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_TYPE_REQUEST, SeahorsePkcs11Request);
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	switch (property_id) {
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		case SEAHORSE_PKCS11_REQUEST_PRIVATE_KEY_PROPERTY:
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		g_value_set_object (value, seahorse_pkcs11_request_get_private_key (self));
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		break;
#line 1235 "pkcs11-request.c"
		default:
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		break;
#line 1241 "pkcs11-request.c"
	}
}


static void
_vala_seahorse_pkcs11_request_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	SeahorsePkcs11Request * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_TYPE_REQUEST, SeahorsePkcs11Request);
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
	switch (property_id) {
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		case SEAHORSE_PKCS11_REQUEST_PRIVATE_KEY_PROPERTY:
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		seahorse_pkcs11_request_set_private_key (self, g_value_get_object (value));
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		break;
#line 1262 "pkcs11-request.c"
		default:
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/builddir/build/BUILD/seahorse-3.32.2/pkcs11/pkcs11-request.vala"
		break;
#line 1268 "pkcs11-request.c"
	}
}



