/* key-data.c generated by valac 0.40.19, the Vala compiler
 * generated from key-data.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2006 Stefan Walter
 * Copyright (C) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>


#define SEAHORSE_SSH_TYPE_KEY_DATA (seahorse_ssh_key_data_get_type ())
#define SEAHORSE_SSH_KEY_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyData))
#define SEAHORSE_SSH_KEY_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyDataClass))
#define SEAHORSE_SSH_IS_KEY_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_SSH_TYPE_KEY_DATA))
#define SEAHORSE_SSH_IS_KEY_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_SSH_TYPE_KEY_DATA))
#define SEAHORSE_SSH_KEY_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyDataClass))

typedef struct _SeahorseSshKeyData SeahorseSshKeyData;
typedef struct _SeahorseSshKeyDataClass SeahorseSshKeyDataClass;
typedef struct _SeahorseSshKeyDataPrivate SeahorseSshKeyDataPrivate;
typedef enum  {
	SEAHORSE_SSH_ALGORITHM_UNKNOWN,
	SEAHORSE_SSH_ALGORITHM_RSA,
	SEAHORSE_SSH_ALGORITHM_DSA,
	SEAHORSE_SSH_ALGORITHM_ECDSA,
	SEAHORSE_SSH_ALGORITHM_ED25519
} SeahorseSshAlgorithm;


#define SEAHORSE_SSH_TYPE_ALGORITHM (seahorse_ssh_algorithm_get_type ())
enum  {
	SEAHORSE_SSH_KEY_DATA_0_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define SEAHORSE_SSH_TYPE_SEC_DATA (seahorse_ssh_sec_data_get_type ())
#define SEAHORSE_SSH_SEC_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecData))
#define SEAHORSE_SSH_SEC_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecDataClass))
#define SEAHORSE_SSH_IS_SEC_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_SSH_TYPE_SEC_DATA))
#define SEAHORSE_SSH_IS_SEC_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_SSH_TYPE_SEC_DATA))
#define SEAHORSE_SSH_SEC_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecDataClass))

typedef struct _SeahorseSshSecData SeahorseSshSecData;
typedef struct _SeahorseSshSecDataClass SeahorseSshSecDataClass;
typedef struct _SeahorseSshSecDataPrivate SeahorseSshSecDataPrivate;
enum  {
	SEAHORSE_SSH_SEC_DATA_0_PROPERTY,
	SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY,
	SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY,
	SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY,
	SEAHORSE_SSH_SEC_DATA_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_NUM_PROPERTIES];

struct _SeahorseSshKeyData {
	GObject parent_instance;
	SeahorseSshKeyDataPrivate * priv;
};

struct _SeahorseSshKeyDataClass {
	GObjectClass parent_class;
};

struct _SeahorseSshKeyDataPrivate {
	gchar* _privfile;
	gchar* _pubfile;
	gboolean _partial;
	gboolean _authorized;
	gchar* _rawdata;
	gchar* _comment;
	gchar* _fingerprint;
	guint _length;
	SeahorseSshAlgorithm _algo;
};

typedef enum  {
	SEAHORSE_SSH_ERROR_GENERAL
} SeahorseSshError;
#define SEAHORSE_SSH_ERROR seahorse_ssh_error_quark ()
struct _SeahorseSshSecData {
	GObject parent_instance;
	SeahorseSshSecDataPrivate * priv;
};

struct _SeahorseSshSecDataClass {
	GObjectClass parent_class;
};

struct _SeahorseSshSecDataPrivate {
	gchar* _rawdata;
	gchar* _comment;
	SeahorseSshAlgorithm _algo;
};


static gpointer seahorse_ssh_key_data_parent_class = NULL;
static gpointer seahorse_ssh_sec_data_parent_class = NULL;

GType seahorse_ssh_key_data_get_type (void) G_GNUC_CONST;
GType seahorse_ssh_algorithm_get_type (void) G_GNUC_CONST;
#define SEAHORSE_SSH_KEY_DATA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyDataPrivate))
gboolean seahorse_ssh_key_data_is_valid (SeahorseSshKeyData* self);
const gchar* seahorse_ssh_key_data_get_fingerprint (SeahorseSshKeyData* self);
gboolean seahorse_ssh_key_data_match (SeahorseSshKeyData* self,
                                      const gchar* line);
SeahorseSshKeyData* seahorse_ssh_key_data_parse_line (const gchar* line,
                                                      GError** error);
GQuark seahorse_ssh_error_quark (void);
SeahorseSshKeyData* seahorse_ssh_key_data_new (void);
SeahorseSshKeyData* seahorse_ssh_key_data_construct (GType object_type);
void seahorse_ssh_key_data_set_rawdata (SeahorseSshKeyData* self,
                                        const gchar* value);
SeahorseSshAlgorithm seahorse_ssh_algorithm_guess_from_string (const gchar* str);
void seahorse_ssh_key_data_set_algo (SeahorseSshKeyData* self,
                                     SeahorseSshAlgorithm value);
SeahorseSshAlgorithm seahorse_ssh_key_data_get_algo (SeahorseSshKeyData* self);
gchar* seahorse_ssh_key_data_parse_key_blob (guchar* bytes,
                                             int bytes_length1,
                                             GError** error);
void seahorse_ssh_key_data_set_fingerprint (SeahorseSshKeyData* self,
                                            const gchar* value);
guint seahorse_ssh_key_data_calc_bits (SeahorseSshAlgorithm algo,
                                       guint len);
void seahorse_ssh_key_data_set_length (SeahorseSshKeyData* self,
                                       guint value);
void seahorse_ssh_key_data_set_comment (SeahorseSshKeyData* self,
                                        const gchar* value);
void seahorse_ssh_key_data_filter_file (const gchar* filename,
                                        SeahorseSshKeyData* add,
                                        SeahorseSshKeyData* remove,
                                        GError** error);
const gchar* seahorse_ssh_key_data_get_rawdata (SeahorseSshKeyData* self);
gchar* seahorse_ssh_key_data_get_location (SeahorseSshKeyData* self);
const gchar* seahorse_ssh_key_data_get_privfile (SeahorseSshKeyData* self);
const gchar* seahorse_ssh_key_data_get_pubfile (SeahorseSshKeyData* self);
void seahorse_ssh_key_data_set_privfile (SeahorseSshKeyData* self,
                                         const gchar* value);
void seahorse_ssh_key_data_set_pubfile (SeahorseSshKeyData* self,
                                        const gchar* value);
gboolean seahorse_ssh_key_data_get_partial (SeahorseSshKeyData* self);
void seahorse_ssh_key_data_set_partial (SeahorseSshKeyData* self,
                                        gboolean value);
gboolean seahorse_ssh_key_data_get_authorized (SeahorseSshKeyData* self);
void seahorse_ssh_key_data_set_authorized (SeahorseSshKeyData* self,
                                           gboolean value);
const gchar* seahorse_ssh_key_data_get_comment (SeahorseSshKeyData* self);
guint seahorse_ssh_key_data_get_length (SeahorseSshKeyData* self);
static void seahorse_ssh_key_data_finalize (GObject * obj);
static void _vala_seahorse_ssh_key_data_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_seahorse_ssh_key_data_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
GType seahorse_ssh_sec_data_get_type (void) G_GNUC_CONST;
#define SEAHORSE_SSH_SEC_DATA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecDataPrivate))
#define SEAHORSE_SSH_SEC_DATA_SSH_KEY_SECRET_SIG "# SSH PRIVATE KEY: "
#define SEAHORSE_SSH_SEC_DATA_SSH_PRIVATE_BEGIN "-----BEGIN "
#define SEAHORSE_SSH_SEC_DATA_SSH_PRIVATE_END "-----END "
gboolean seahorse_ssh_sec_data_contains_private_key (const gchar* data);
SeahorseSshSecData* seahorse_ssh_sec_data_parse_data (GString* data,
                                                      GError** error);
SeahorseSshSecData* seahorse_ssh_sec_data_new (void);
SeahorseSshSecData* seahorse_ssh_sec_data_construct (GType object_type);
void seahorse_ssh_sec_data_set_comment (SeahorseSshSecData* self,
                                        const gchar* value);
static gchar* seahorse_ssh_sec_data_parse_lines_block (GString* data,
                                                const gchar* start,
                                                const gchar* end);
void seahorse_ssh_sec_data_set_rawdata (SeahorseSshSecData* self,
                                        const gchar* value);
void seahorse_ssh_sec_data_set_algo (SeahorseSshSecData* self,
                                     SeahorseSshAlgorithm value);
const gchar* seahorse_ssh_sec_data_get_rawdata (SeahorseSshSecData* self);
const gchar* seahorse_ssh_sec_data_get_comment (SeahorseSshSecData* self);
SeahorseSshAlgorithm seahorse_ssh_sec_data_get_algo (SeahorseSshSecData* self);
static void seahorse_ssh_sec_data_finalize (GObject * obj);
static void _vala_seahorse_ssh_sec_data_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_seahorse_ssh_sec_data_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


gboolean
seahorse_ssh_key_data_is_valid (SeahorseSshKeyData* self)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
#line 36 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_fingerprint;
#line 37 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_ != NULL;
#line 37 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 246 "key-data.c"
}


/**
     * Checks whether this key and another (in the form of a string) match.
     */
gboolean
seahorse_ssh_key_data_match (SeahorseSshKeyData* self,
                             const gchar* line)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 44 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (!seahorse_ssh_key_data_is_valid (self)) {
#line 45 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		result = FALSE;
#line 45 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return result;
#line 269 "key-data.c"
	}
	{
		SeahorseSshKeyData* other = NULL;
		SeahorseSshKeyData* _tmp0_;
		gboolean _tmp1_ = FALSE;
		SeahorseSshKeyData* _tmp2_;
		const gchar* _tmp3_;
#line 48 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = seahorse_ssh_key_data_parse_line (line, &_inner_error0_);
#line 48 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		other = _tmp0_;
#line 48 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "key-data.c"
			goto __catch3_g_error;
		}
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp2_ = other;
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp3_ = _tmp2_->priv->_fingerprint;
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		if (_tmp3_ != NULL) {
#line 292 "key-data.c"
			const gchar* _tmp4_;
			SeahorseSshKeyData* _tmp5_;
			const gchar* _tmp6_;
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp4_ = self->priv->_fingerprint;
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp5_ = other;
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp6_ = _tmp5_->priv->_fingerprint;
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp1_ = g_strcmp0 (_tmp4_, _tmp6_) == 0;
#line 304 "key-data.c"
		} else {
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp1_ = FALSE;
#line 308 "key-data.c"
		}
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		result = _tmp1_;
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_object_unref0 (other);
#line 49 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return result;
#line 316 "key-data.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		e = _inner_error0_;
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_inner_error0_ = NULL;
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp7_ = e;
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp8_ = _tmp7_->message;
#line 51 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_warning ("key-data.vala:51: %s", _tmp8_);
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_error_free0 (e);
#line 336 "key-data.c"
	}
	__finally3:
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 341 "key-data.c"
		gboolean _tmp9_ = FALSE;
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_clear_error (&_inner_error0_);
#line 47 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return _tmp9_;
#line 349 "key-data.c"
	}
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = FALSE;
#line 54 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 355 "key-data.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1307 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 380 "key-data.c"
}


static gchar*
string_chug (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1296 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1297 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1297 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1298 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1298 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strchug (_tmp1_);
#line 1299 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1299 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 405 "key-data.c"
}


SeahorseSshKeyData*
seahorse_ssh_key_data_parse_line (const gchar* line,
                                  GError** error)
{
	SeahorseSshKeyData* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* no_leading = NULL;
	gchar* _tmp4_;
	SeahorseSshKeyData* _result_ = NULL;
	SeahorseSshKeyData* _tmp5_;
	SeahorseSshKeyData* _tmp6_;
	const gchar* _tmp7_;
	gchar** type_rest = NULL;
	const gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint type_rest_length1;
	gint _type_rest_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* type = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	SeahorseSshKeyData* _tmp18_;
	const gchar* _tmp19_;
	SeahorseSshKeyData* _tmp20_;
	SeahorseSshAlgorithm _tmp21_;
	gchar* rest = NULL;
	gchar** _tmp27_;
	gint _tmp27__length1;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar** data_comment = NULL;
	const gchar* _tmp32_;
	gchar** _tmp33_;
	gchar** _tmp34_;
	gint data_comment_length1;
	gint _data_comment_size_;
	guchar* bytes = NULL;
	gchar** _tmp35_;
	gint _tmp35__length1;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	size_t _tmp39_ = 0;
	guchar* _tmp40_;
	guchar* _tmp41_;
	gint _tmp41__length1;
	gint bytes_length1;
	gint _bytes_size_;
	gchar* _tmp42_ = NULL;
	guchar* _tmp43_;
	gint _tmp43__length1;
	gchar* _tmp44_;
	SeahorseSshKeyData* _tmp45_;
	SeahorseSshKeyData* _tmp46_;
	SeahorseSshKeyData* _tmp47_;
	SeahorseSshAlgorithm _tmp48_;
	guchar* _tmp49_;
	gint _tmp49__length1;
	gchar** _tmp50_;
	gint _tmp50__length1;
	GError* _inner_error0_ = NULL;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (line == NULL) {
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = TRUE;
#line 480 "key-data.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp1_ = string_strip (line);
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp2_ = _tmp1_;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (_tmp2_);
#line 492 "key-data.c"
	}
#line 58 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (_tmp0_) {
#line 496 "key-data.c"
		GError* _tmp3_;
#line 59 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp3_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't parse key from empty line.");
#line 59 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_inner_error0_ = _tmp3_;
#line 59 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 59 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return NULL;
#line 506 "key-data.c"
	}
#line 61 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp4_ = string_chug (line);
#line 61 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	no_leading = _tmp4_;
#line 62 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp5_ = seahorse_ssh_key_data_new ();
#line 62 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_result_ = _tmp5_;
#line 63 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp6_ = _result_;
#line 63 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp7_ = no_leading;
#line 63 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	seahorse_ssh_key_data_set_rawdata (_tmp6_, _tmp7_);
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp8_ = no_leading;
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp10_ = _tmp9_ = g_strsplit_set (_tmp8_, " \t", 2);
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	type_rest = _tmp10_;
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	type_rest_length1 = _vala_array_length (_tmp9_);
#line 66 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_type_rest_size_ = type_rest_length1;
#line 67 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp11_ = type_rest;
#line 67 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp11__length1 = type_rest_length1;
#line 67 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (_tmp11__length1 != 2) {
#line 538 "key-data.c"
		GError* _tmp12_;
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp12_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't distinguish type from data (space missing).");
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_inner_error0_ = _tmp12_;
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (no_leading);
#line 68 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return NULL;
#line 554 "key-data.c"
	}
#line 70 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp13_ = type_rest;
#line 70 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp13__length1 = type_rest_length1;
#line 70 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp14_ = _tmp13_[0];
#line 70 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 70 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	type = _tmp15_;
#line 71 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp16_ = type;
#line 71 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_strcmp0 (_tmp16_, "") == 0) {
#line 570 "key-data.c"
		GError* _tmp17_;
#line 72 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp17_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Key doesn't have a type.");
#line 72 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_inner_error0_ = _tmp17_;
#line 72 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 72 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (type);
#line 72 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 72 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 72 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (no_leading);
#line 72 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return NULL;
#line 588 "key-data.c"
	}
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp18_ = _result_;
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp19_ = type;
#line 74 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	seahorse_ssh_key_data_set_algo (_tmp18_, seahorse_ssh_algorithm_guess_from_string (_tmp19_));
#line 75 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp20_ = _result_;
#line 75 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp21_ = _tmp20_->priv->_algo;
#line 75 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (_tmp21_ == SEAHORSE_SSH_ALGORITHM_UNKNOWN) {
#line 602 "key-data.c"
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GError* _tmp25_;
		GError* _tmp26_;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp22_ = type;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp23_ = g_strdup_printf ("Key doesn't have a valid type (%s).", _tmp22_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp24_ = _tmp23_;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp25_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, _tmp24_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp26_ = _tmp25_;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (_tmp24_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_inner_error0_ = _tmp26_;
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (type);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (no_leading);
#line 76 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return NULL;
#line 634 "key-data.c"
	}
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp27_ = type_rest;
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp27__length1 = type_rest_length1;
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp28_ = _tmp27_[1];
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 79 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	rest = _tmp29_;
#line 80 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp30_ = rest;
#line 80 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_strcmp0 (_tmp30_, "") == 0) {
#line 650 "key-data.c"
		GError* _tmp31_;
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp31_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Key doesn't have any data.");
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_inner_error0_ = _tmp31_;
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (rest);
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (type);
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (no_leading);
#line 81 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return NULL;
#line 670 "key-data.c"
	}
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp32_ = rest;
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp34_ = _tmp33_ = g_strsplit_set (_tmp32_, " \t", 2);
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	data_comment = _tmp34_;
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	data_comment_length1 = _vala_array_length (_tmp33_);
#line 82 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_data_comment_size_ = data_comment_length1;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp35_ = data_comment;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp35__length1 = data_comment_length1;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp36_ = _tmp35_[0];
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp37_ = string_strip (_tmp36_);
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp38_ = _tmp37_;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp40_ = g_base64_decode (_tmp38_, &_tmp39_);
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp41_ = _tmp40_;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp41__length1 = _tmp39_;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (_tmp38_);
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	bytes = _tmp41_;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	bytes_length1 = _tmp41__length1;
#line 85 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_bytes_size_ = bytes_length1;
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp43_ = bytes;
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp43__length1 = bytes_length1;
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp44_ = seahorse_ssh_key_data_parse_key_blob (_tmp43_, _tmp43__length1, &_inner_error0_);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp42_ = _tmp44_;
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		bytes = (g_free (bytes), NULL);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		data_comment = (_vala_array_free (data_comment, data_comment_length1, (GDestroyNotify) g_free), NULL);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (rest);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (type);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (no_leading);
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return NULL;
#line 734 "key-data.c"
	}
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp45_ = _result_;
#line 86 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	seahorse_ssh_key_data_set_fingerprint (_tmp45_, _tmp42_);
#line 89 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp46_ = _result_;
#line 89 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp47_ = _result_;
#line 89 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp48_ = _tmp47_->priv->_algo;
#line 89 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp49_ = bytes;
#line 89 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp49__length1 = bytes_length1;
#line 89 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	seahorse_ssh_key_data_set_length (_tmp46_, seahorse_ssh_key_data_calc_bits (_tmp48_, (guint) _tmp49__length1));
#line 92 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp50_ = data_comment;
#line 92 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp50__length1 = data_comment_length1;
#line 92 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (_tmp50__length1 == 2) {
#line 758 "key-data.c"
		gchar* comment = NULL;
		gchar** _tmp51_;
		gint _tmp51__length1;
		const gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
#line 93 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp51_ = data_comment;
#line 93 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp51__length1 = data_comment_length1;
#line 93 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp52_ = _tmp51_[1];
#line 93 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp53_ = g_strdup (_tmp52_);
#line 93 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		comment = _tmp53_;
#line 95 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp54_ = comment;
#line 95 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		if (!g_utf8_validate (_tmp54_, (gssize) -1, NULL)) {
#line 779 "key-data.c"
			gchar* _tmp55_ = NULL;
			const gchar* _tmp56_;
			const gchar* _tmp57_;
			gint _tmp58_;
			gint _tmp59_;
			gchar* _tmp60_;
			SeahorseSshKeyData* _tmp61_;
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp56_ = comment;
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp57_ = comment;
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp58_ = strlen (_tmp57_);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp59_ = _tmp58_;
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp60_ = g_convert (_tmp56_, (gssize) _tmp59_, "UTF-8", "ISO-8859-1", NULL, NULL, &_inner_error0_);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp55_ = _tmp60_;
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				g_propagate_error (error, _inner_error0_);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_g_free0 (comment);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_g_free0 (_tmp42_);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				bytes = (g_free (bytes), NULL);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				data_comment = (_vala_array_free (data_comment, data_comment_length1, (GDestroyNotify) g_free), NULL);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_g_free0 (rest);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_g_free0 (type);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_g_object_unref0 (_result_);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_g_free0 (no_leading);
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				return NULL;
#line 823 "key-data.c"
			}
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp61_ = _result_;
#line 96 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			seahorse_ssh_key_data_set_comment (_tmp61_, _tmp55_);
#line 95 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_g_free0 (_tmp55_);
#line 831 "key-data.c"
		} else {
			SeahorseSshKeyData* _tmp62_;
			const gchar* _tmp63_;
#line 98 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp62_ = _result_;
#line 98 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp63_ = comment;
#line 98 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			seahorse_ssh_key_data_set_comment (_tmp62_, _tmp63_);
#line 841 "key-data.c"
		}
#line 92 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (comment);
#line 845 "key-data.c"
	}
#line 101 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _result_;
#line 101 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (_tmp42_);
#line 101 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	bytes = (g_free (bytes), NULL);
#line 101 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	data_comment = (_vala_array_free (data_comment, data_comment_length1, (GDestroyNotify) g_free), NULL);
#line 101 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (rest);
#line 101 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (type);
#line 101 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 101 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (no_leading);
#line 101 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 865 "key-data.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = maxlen;
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 889 "key-data.c"
	} else {
		gchar* _tmp2_;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 898 "key-data.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1403 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 919 "key-data.c"
	} else {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 923 "key-data.c"
	}
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 929 "key-data.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 939 "key-data.c"
	}
#line 1412 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 943 "key-data.c"
		glong _tmp3_;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1414 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 951 "key-data.c"
	} else {
		glong _tmp4_;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 958 "key-data.c"
	}
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 962 "key-data.c"
		glong _tmp5_;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 968 "key-data.c"
	}
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp7_;
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 980 "key-data.c"
}


gchar*
seahorse_ssh_key_data_parse_key_blob (guchar* bytes,
                                      int bytes_length1,
                                      GError** error)
{
	gchar* result = NULL;
	gchar* digest = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GString* fingerprint = NULL;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GString* _tmp6_;
	GString* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 105 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = g_compute_checksum_for_data (G_CHECKSUM_MD5, bytes, bytes_length1);
#line 105 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	digest = _tmp0_;
#line 106 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp1_ = digest;
#line 106 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (_tmp1_ == NULL) {
#line 1010 "key-data.c"
		GError* _tmp2_;
#line 107 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp2_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't calculate fingerprint from key.");
#line 107 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_inner_error0_ = _tmp2_;
#line 107 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 107 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (digest);
#line 107 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return NULL;
#line 1022 "key-data.c"
	}
#line 109 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp3_ = digest;
#line 109 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp4_ = strlen (_tmp3_);
#line 109 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp5_ = _tmp4_;
#line 109 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp6_ = g_string_sized_new ((gsize) ((_tmp5_ * 3) / 2));
#line 109 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	fingerprint = _tmp6_;
#line 1034 "key-data.c"
	{
		gsize i = 0UL;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		i = (gsize) 0;
#line 1039 "key-data.c"
		{
			gboolean _tmp7_ = FALSE;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp7_ = TRUE;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			while (TRUE) {
#line 1046 "key-data.c"
				gsize _tmp9_;
				const gchar* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gsize _tmp13_;
				GString* _tmp15_;
				const gchar* _tmp16_;
				gsize _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				if (!_tmp7_) {
#line 1059 "key-data.c"
					gsize _tmp8_;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp8_ = i;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					i = _tmp8_ + 2;
#line 1065 "key-data.c"
				}
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp7_ = FALSE;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp9_ = i;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp10_ = digest;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp11_ = strlen (_tmp10_);
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp12_ = _tmp11_;
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				if (!(_tmp9_ < ((gsize) _tmp12_))) {
#line 110 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					break;
#line 1081 "key-data.c"
				}
#line 111 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp13_ = i;
#line 111 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				if (_tmp13_ > ((gsize) 0)) {
#line 1087 "key-data.c"
					GString* _tmp14_;
#line 112 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp14_ = fingerprint;
#line 112 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					g_string_append_c (_tmp14_, ':');
#line 1093 "key-data.c"
				}
#line 113 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp15_ = fingerprint;
#line 113 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp16_ = digest;
#line 113 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp17_ = i;
#line 113 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp18_ = string_substring (_tmp16_, (glong) _tmp17_, (glong) 2);
#line 113 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp19_ = _tmp18_;
#line 113 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				g_string_append (_tmp15_, _tmp19_);
#line 113 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_g_free0 (_tmp19_);
#line 1109 "key-data.c"
			}
		}
	}
#line 116 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp20_ = fingerprint;
#line 116 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp21_ = _tmp20_->str;
#line 116 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 116 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp22_;
#line 116 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_string_free0 (fingerprint);
#line 116 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (digest);
#line 116 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1127 "key-data.c"
}


guint
seahorse_ssh_key_data_calc_bits (SeahorseSshAlgorithm algo,
                                 guint len)
{
	guint result = 0U;
#line 123 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	switch (algo) {
#line 123 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_ALGORITHM_RSA:
#line 1140 "key-data.c"
		{
#line 126 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			result = (len - 23) * 8;
#line 126 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			return result;
#line 1146 "key-data.c"
		}
#line 123 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_ALGORITHM_DSA:
#line 1150 "key-data.c"
		{
			guint n = 0U;
			gint _tmp0_ = 0;
			guint _tmp1_;
			guint _tmp2_;
#line 130 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			n = ((len - 50) * 8) / 3;
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp1_ = n;
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			if ((_tmp1_ % 64) > ((guint) 32)) {
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp0_ = 1;
#line 1164 "key-data.c"
			} else {
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp0_ = 0;
#line 1168 "key-data.c"
			}
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp2_ = n;
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			result = ((_tmp2_ / 64) + _tmp0_) * 64;
#line 131 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			return result;
#line 1176 "key-data.c"
		}
#line 123 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_ALGORITHM_ED25519:
#line 1180 "key-data.c"
		{
#line 134 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			result = (guint) 256;
#line 134 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			return result;
#line 1186 "key-data.c"
		}
		default:
		{
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			result = (guint) 0;
#line 137 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			return result;
#line 1194 "key-data.c"
		}
	}
}


void
seahorse_ssh_key_data_filter_file (const gchar* filename,
                                   SeahorseSshKeyData* add,
                                   SeahorseSshKeyData* remove,
                                   GError** error)
{
	gchar* contents = NULL;
	gchar* _tmp0_ = NULL;
	GString* results = NULL;
	GString* _tmp1_;
	gboolean first = FALSE;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar** lines = NULL;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GString* _tmp18_;
	const gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (filename != NULL);
#line 144 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (remove == NULL) {
#line 145 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		remove = add;
#line 1229 "key-data.c"
	}
#line 148 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_file_get_contents (filename, &_tmp0_, NULL, &_inner_error0_);
#line 148 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (contents);
#line 148 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	contents = _tmp0_;
#line 148 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 148 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (contents);
#line 148 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return;
#line 1245 "key-data.c"
	}
#line 150 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp1_ = g_string_new ("");
#line 150 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	results = _tmp1_;
#line 153 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	first = TRUE;
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp3_ = contents;
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp2_ = _tmp3_;
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (_tmp2_ == NULL) {
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp2_ = "";
#line 1261 "key-data.c"
	}
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp2_, "\n", 0);
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	lines = _tmp5_;
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	lines_length1 = _vala_array_length (_tmp4_);
#line 154 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_lines_size_ = lines_length1;
#line 155 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp6_ = lines;
#line 155 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp6__length1 = lines_length1;
#line 1275 "key-data.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 155 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		line_collection = _tmp6_;
#line 155 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		line_collection_length1 = _tmp6__length1;
#line 155 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1287 "key-data.c"
			gchar* _tmp7_;
			gchar* line = NULL;
#line 155 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp7_ = g_strdup (line_collection[line_it]);
#line 155 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			line = _tmp7_;
#line 1294 "key-data.c"
			{
				gboolean _tmp8_ = FALSE;
				gboolean _tmp10_;
				GString* _tmp12_;
				const gchar* _tmp13_;
#line 156 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				if (remove != NULL) {
#line 1302 "key-data.c"
					const gchar* _tmp9_;
#line 156 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp9_ = line;
#line 156 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp8_ = seahorse_ssh_key_data_match (remove, _tmp9_);
#line 1308 "key-data.c"
				} else {
#line 156 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp8_ = FALSE;
#line 1312 "key-data.c"
				}
#line 156 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				if (_tmp8_) {
#line 157 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_g_free0 (line);
#line 157 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					continue;
#line 1320 "key-data.c"
				}
#line 159 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp10_ = first;
#line 159 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				if (!_tmp10_) {
#line 1326 "key-data.c"
					GString* _tmp11_;
#line 160 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp11_ = results;
#line 160 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					g_string_append_c (_tmp11_, '\n');
#line 1332 "key-data.c"
				}
#line 161 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				first = FALSE;
#line 162 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp12_ = results;
#line 162 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp13_ = line;
#line 162 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				g_string_append (_tmp12_, _tmp13_);
#line 155 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_g_free0 (line);
#line 1344 "key-data.c"
			}
		}
	}
#line 166 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (add != NULL) {
#line 1350 "key-data.c"
		gboolean _tmp14_;
		GString* _tmp16_;
		const gchar* _tmp17_;
#line 167 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp14_ = first;
#line 167 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		if (!_tmp14_) {
#line 1358 "key-data.c"
			GString* _tmp15_;
#line 168 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp15_ = results;
#line 168 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			g_string_append_c (_tmp15_, '\n');
#line 1364 "key-data.c"
		}
#line 169 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp16_ = results;
#line 169 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp17_ = add->priv->_rawdata;
#line 169 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_string_append (_tmp16_, _tmp17_);
#line 1372 "key-data.c"
	}
#line 172 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp18_ = results;
#line 172 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp19_ = _tmp18_->str;
#line 172 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_file_set_contents (filename, _tmp19_, (gssize) -1, &_inner_error0_);
#line 172 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 172 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 172 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_string_free0 (results);
#line 172 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (contents);
#line 172 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return;
#line 1392 "key-data.c"
	}
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_string_free0 (results);
#line 142 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (contents);
#line 1400 "key-data.c"
}


gchar*
seahorse_ssh_key_data_get_location (SeahorseSshKeyData* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* _tmp4_;
#line 175 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 176 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp1_ = self->priv->_privfile;
#line 176 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (_tmp1_ != NULL) {
#line 1417 "key-data.c"
		const gchar* _tmp2_;
#line 176 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp2_ = self->priv->_privfile;
#line 176 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = _tmp2_;
#line 1423 "key-data.c"
	} else {
		const gchar* _tmp3_;
#line 176 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp3_ = self->priv->_pubfile;
#line 176 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = _tmp3_;
#line 1430 "key-data.c"
	}
#line 176 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp4_ = g_strdup (_tmp0_);
#line 176 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp4_;
#line 176 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1438 "key-data.c"
}


SeahorseSshKeyData*
seahorse_ssh_key_data_construct (GType object_type)
{
	SeahorseSshKeyData * self = NULL;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	self = (SeahorseSshKeyData*) g_object_new (object_type, NULL);
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return self;
#line 1450 "key-data.c"
}


SeahorseSshKeyData*
seahorse_ssh_key_data_new (void)
{
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return seahorse_ssh_key_data_construct (SEAHORSE_SSH_TYPE_KEY_DATA);
#line 1459 "key-data.c"
}


const gchar*
seahorse_ssh_key_data_get_privfile (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_privfile;
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1476 "key-data.c"
}


void
seahorse_ssh_key_data_set_privfile (SeahorseSshKeyData* self,
                                    const gchar* value)
{
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_strcmp0 (value, seahorse_ssh_key_data_get_privfile (self)) != 0) {
#line 1488 "key-data.c"
		gchar* _tmp0_;
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (self->priv->_privfile);
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_privfile = _tmp0_;
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY]);
#line 1498 "key-data.c"
	}
}


const gchar*
seahorse_ssh_key_data_get_pubfile (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_pubfile;
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1516 "key-data.c"
}


void
seahorse_ssh_key_data_set_pubfile (SeahorseSshKeyData* self,
                                   const gchar* value)
{
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_strcmp0 (value, seahorse_ssh_key_data_get_pubfile (self)) != 0) {
#line 1528 "key-data.c"
		gchar* _tmp0_;
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (self->priv->_pubfile);
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_pubfile = _tmp0_;
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY]);
#line 1538 "key-data.c"
	}
}


gboolean
seahorse_ssh_key_data_get_partial (SeahorseSshKeyData* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_partial;
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1556 "key-data.c"
}


void
seahorse_ssh_key_data_set_partial (SeahorseSshKeyData* self,
                                   gboolean value)
{
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (seahorse_ssh_key_data_get_partial (self) != value) {
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_partial = value;
#line 26 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY]);
#line 1572 "key-data.c"
	}
}


gboolean
seahorse_ssh_key_data_get_authorized (SeahorseSshKeyData* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_authorized;
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1590 "key-data.c"
}


void
seahorse_ssh_key_data_set_authorized (SeahorseSshKeyData* self,
                                      gboolean value)
{
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (seahorse_ssh_key_data_get_authorized (self) != value) {
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_authorized = value;
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY]);
#line 1606 "key-data.c"
	}
}


const gchar*
seahorse_ssh_key_data_get_rawdata (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_rawdata;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1624 "key-data.c"
}


void
seahorse_ssh_key_data_set_rawdata (SeahorseSshKeyData* self,
                                   const gchar* value)
{
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_strcmp0 (value, seahorse_ssh_key_data_get_rawdata (self)) != 0) {
#line 1636 "key-data.c"
		gchar* _tmp0_;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (self->priv->_rawdata);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_rawdata = _tmp0_;
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY]);
#line 1646 "key-data.c"
	}
}


const gchar*
seahorse_ssh_key_data_get_comment (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_comment;
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1664 "key-data.c"
}


void
seahorse_ssh_key_data_set_comment (SeahorseSshKeyData* self,
                                   const gchar* value)
{
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_strcmp0 (value, seahorse_ssh_key_data_get_comment (self)) != 0) {
#line 1676 "key-data.c"
		gchar* _tmp0_;
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (self->priv->_comment);
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_comment = _tmp0_;
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY]);
#line 1686 "key-data.c"
	}
}


const gchar*
seahorse_ssh_key_data_get_fingerprint (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_fingerprint;
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1704 "key-data.c"
}


void
seahorse_ssh_key_data_set_fingerprint (SeahorseSshKeyData* self,
                                       const gchar* value)
{
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_strcmp0 (value, seahorse_ssh_key_data_get_fingerprint (self)) != 0) {
#line 1716 "key-data.c"
		gchar* _tmp0_;
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (self->priv->_fingerprint);
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_fingerprint = _tmp0_;
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY]);
#line 1726 "key-data.c"
	}
}


guint
seahorse_ssh_key_data_get_length (SeahorseSshKeyData* self)
{
	guint result;
	guint _tmp0_;
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_length;
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1744 "key-data.c"
}


void
seahorse_ssh_key_data_set_length (SeahorseSshKeyData* self,
                                  guint value)
{
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (seahorse_ssh_key_data_get_length (self) != value) {
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_length = value;
#line 33 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY]);
#line 1760 "key-data.c"
	}
}


SeahorseSshAlgorithm
seahorse_ssh_key_data_get_algo (SeahorseSshKeyData* self)
{
	SeahorseSshAlgorithm result;
	SeahorseSshAlgorithm _tmp0_;
#line 34 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_algo;
#line 34 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 1778 "key-data.c"
}


void
seahorse_ssh_key_data_set_algo (SeahorseSshKeyData* self,
                                SeahorseSshAlgorithm value)
{
#line 34 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (seahorse_ssh_key_data_get_algo (self) != value) {
#line 34 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_algo = value;
#line 34 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY]);
#line 1794 "key-data.c"
	}
}


static void
seahorse_ssh_key_data_class_init (SeahorseSshKeyDataClass * klass)
{
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	seahorse_ssh_key_data_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_type_class_add_private (klass, sizeof (SeahorseSshKeyDataPrivate));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_ssh_key_data_get_property;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_ssh_key_data_set_property;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_key_data_finalize;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY] = g_param_spec_string ("privfile", "privfile", "privfile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY] = g_param_spec_string ("pubfile", "pubfile", "pubfile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY] = g_param_spec_boolean ("partial", "partial", "partial", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY] = g_param_spec_boolean ("authorized", "authorized", "authorized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY] = g_param_spec_string ("rawdata", "rawdata", "rawdata", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY] = g_param_spec_string ("fingerprint", "fingerprint", "fingerprint", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY] = g_param_spec_enum ("algo", "algo", "algo", SEAHORSE_SSH_TYPE_ALGORITHM, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1830 "key-data.c"
}


static void
seahorse_ssh_key_data_instance_init (SeahorseSshKeyData * self)
{
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	self->priv = SEAHORSE_SSH_KEY_DATA_GET_PRIVATE (self);
#line 27 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	self->priv->_authorized = FALSE;
#line 1841 "key-data.c"
}


static void
seahorse_ssh_key_data_finalize (GObject * obj)
{
	SeahorseSshKeyData * self;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyData);
#line 24 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (self->priv->_privfile);
#line 25 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (self->priv->_pubfile);
#line 30 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (self->priv->_rawdata);
#line 31 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (self->priv->_comment);
#line 32 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (self->priv->_fingerprint);
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	G_OBJECT_CLASS (seahorse_ssh_key_data_parent_class)->finalize (obj);
#line 1863 "key-data.c"
}


GType
seahorse_ssh_key_data_get_type (void)
{
	static volatile gsize seahorse_ssh_key_data_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_ssh_key_data_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshKeyDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_key_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshKeyData), 0, (GInstanceInitFunc) seahorse_ssh_key_data_instance_init, NULL };
		GType seahorse_ssh_key_data_type_id;
		seahorse_ssh_key_data_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseSshKeyData", &g_define_type_info, 0);
		g_once_init_leave (&seahorse_ssh_key_data_type_id__volatile, seahorse_ssh_key_data_type_id);
	}
	return seahorse_ssh_key_data_type_id__volatile;
}


static void
_vala_seahorse_ssh_key_data_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	SeahorseSshKeyData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyData);
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_privfile (self));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_pubfile (self));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_boolean (value, seahorse_ssh_key_data_get_partial (self));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_boolean (value, seahorse_ssh_key_data_get_authorized (self));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_rawdata (self));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_comment (self));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_fingerprint (self));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_uint (value, seahorse_ssh_key_data_get_length (self));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_enum (value, seahorse_ssh_key_data_get_algo (self));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 1945 "key-data.c"
		default:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 1951 "key-data.c"
	}
}


static void
_vala_seahorse_ssh_key_data_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	SeahorseSshKeyData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyData);
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_key_data_set_privfile (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_key_data_set_pubfile (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_key_data_set_partial (self, g_value_get_boolean (value));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_key_data_set_authorized (self, g_value_get_boolean (value));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_key_data_set_rawdata (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_key_data_set_comment (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_key_data_set_fingerprint (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_key_data_set_length (self, g_value_get_uint (value));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_key_data_set_algo (self, g_value_get_enum (value));
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 2020 "key-data.c"
		default:
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 2026 "key-data.c"
	}
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1475 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1475 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1476 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1476 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1476 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 2047 "key-data.c"
}


gboolean
seahorse_ssh_sec_data_contains_private_key (const gchar* data)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 197 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 198 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (string_contains (data, SEAHORSE_SSH_SEC_DATA_SSH_KEY_SECRET_SIG)) {
#line 198 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = TRUE;
#line 2062 "key-data.c"
	} else {
#line 198 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = string_contains (data, SEAHORSE_SSH_SEC_DATA_SSH_PRIVATE_BEGIN);
#line 2066 "key-data.c"
	}
#line 198 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 198 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 2072 "key-data.c"
}


/**
     * Finds the first occurence of a private key in the given string and parses it if found.
     * NOTE: after parsing, it will *remove* the data with the private key from the string.
     *
     * @param data The data that contains a private key.
     */
SeahorseSshSecData*
seahorse_ssh_sec_data_parse_data (GString* data,
                                  GError** error)
{
	SeahorseSshSecData* result = NULL;
	SeahorseSshSecData* secdata = NULL;
	SeahorseSshSecData* _tmp0_;
	const gchar* _tmp1_;
	gchar* rawdata = NULL;
	gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	SeahorseSshSecData* _tmp22_;
	const gchar* _tmp23_;
	SeahorseSshSecData* _tmp24_;
	const gchar* _tmp25_;
	GError* _inner_error0_ = NULL;
#line 207 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 208 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = seahorse_ssh_sec_data_new ();
#line 208 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	secdata = _tmp0_;
#line 211 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp1_ = data->str;
#line 211 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_str_has_prefix (_tmp1_, SEAHORSE_SSH_SEC_DATA_SSH_KEY_SECRET_SIG)) {
#line 2109 "key-data.c"
		gchar* comment = NULL;
		const gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		SeahorseSshSecData* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 212 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp2_ = data->str;
#line 212 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 2);
#line 212 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp5_ = _tmp4_;
#line 212 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp5__length1 = _vala_array_length (_tmp3_);
#line 212 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp6_ = _tmp5_[0];
#line 212 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 212 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp8_ = _tmp7_;
#line 212 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 212 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		comment = _tmp8_;
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp9_ = secdata;
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp10_ = comment;
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp11_ = strlen (SEAHORSE_SSH_SEC_DATA_SSH_KEY_SECRET_SIG);
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp12_ = _tmp11_;
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp13_ = string_substring (_tmp10_, (glong) _tmp12_, (glong) -1);
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp14_ = _tmp13_;
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp15_ = string_strip (_tmp14_);
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp16_ = _tmp15_;
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_sec_data_set_comment (_tmp9_, _tmp16_);
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (_tmp16_);
#line 213 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (_tmp14_);
#line 211 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (comment);
#line 2169 "key-data.c"
	}
#line 217 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp17_ = seahorse_ssh_sec_data_parse_lines_block (data, SEAHORSE_SSH_SEC_DATA_SSH_PRIVATE_BEGIN, SEAHORSE_SSH_SEC_DATA_SSH_PRIVATE_END);
#line 217 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	rawdata = _tmp17_;
#line 218 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp19_ = rawdata;
#line 218 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (_tmp19_ == NULL) {
#line 218 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp18_ = TRUE;
#line 2181 "key-data.c"
	} else {
		const gchar* _tmp20_;
#line 218 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp20_ = rawdata;
#line 218 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp18_ = g_strcmp0 (_tmp20_, "") == 0;
#line 2188 "key-data.c"
	}
#line 218 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (_tmp18_) {
#line 2192 "key-data.c"
		GError* _tmp21_;
#line 219 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp21_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Private key contains no data.");
#line 219 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_inner_error0_ = _tmp21_;
#line 219 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 219 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (rawdata);
#line 219 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_object_unref0 (secdata);
#line 219 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		return NULL;
#line 2206 "key-data.c"
	}
#line 221 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp22_ = secdata;
#line 221 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp23_ = rawdata;
#line 221 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	seahorse_ssh_sec_data_set_rawdata (_tmp22_, _tmp23_);
#line 224 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp24_ = secdata;
#line 224 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp25_ = rawdata;
#line 224 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	seahorse_ssh_sec_data_set_algo (_tmp24_, seahorse_ssh_algorithm_guess_from_string (_tmp25_));
#line 226 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = secdata;
#line 226 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (rawdata);
#line 226 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 2226 "key-data.c"
}


/**
     * Takes everything between the start and end pattern and returns it.
     * NOTE: The string (if found will) be removed from the argument.
     */
static gchar*
seahorse_ssh_sec_data_parse_lines_block (GString* data,
                                         const gchar* start,
                                         const gchar* end)
{
	gchar* result = NULL;
	GString* _result_ = NULL;
	GString* _tmp0_;
	gboolean start_found = FALSE;
	gchar** lines = NULL;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GString* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
#line 233 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 233 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (start != NULL, NULL);
#line 233 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (end != NULL, NULL);
#line 234 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = g_string_new ("");
#line 234 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_result_ = _tmp0_;
#line 236 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	start_found = FALSE;
#line 237 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp1_ = data->str;
#line 237 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, "\n", 0);
#line 237 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	lines = _tmp3_;
#line 237 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	lines_length1 = _vala_array_length (_tmp2_);
#line 237 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_lines_size_ = lines_length1;
#line 238 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp4_ = lines;
#line 238 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp4__length1 = lines_length1;
#line 2280 "key-data.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 238 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		line_collection = _tmp4_;
#line 238 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		line_collection_length1 = _tmp4__length1;
#line 238 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 2292 "key-data.c"
			gchar* _tmp5_;
			gchar* line = NULL;
#line 238 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 238 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
			line = _tmp5_;
#line 2299 "key-data.c"
			{
				gboolean _tmp6_;
#line 240 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_tmp6_ = start_found;
#line 240 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				if (!_tmp6_) {
#line 2306 "key-data.c"
					const gchar* _tmp7_;
#line 241 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp7_ = line;
#line 241 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					if (string_contains (_tmp7_, start)) {
#line 2312 "key-data.c"
						GString* _tmp8_;
						const gchar* _tmp9_;
						GString* _tmp10_;
						const gchar* _tmp11_;
						gint _tmp12_;
						gint _tmp13_;
#line 242 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						_tmp8_ = _result_;
#line 242 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						_tmp9_ = line;
#line 242 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						g_string_append_printf (_tmp8_, "%s\n", _tmp9_);
#line 243 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						_tmp10_ = _result_;
#line 243 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						_tmp11_ = line;
#line 243 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						_tmp12_ = strlen (_tmp11_);
#line 243 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						_tmp13_ = _tmp12_;
#line 243 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						g_string_erase (_tmp10_, (gssize) 0, (gssize) (_tmp13_ + 1));
#line 244 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						start_found = TRUE;
#line 245 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						_g_free0 (line);
#line 245 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						continue;
#line 2341 "key-data.c"
					}
				} else {
					GString* _tmp14_;
					const gchar* _tmp15_;
					GString* _tmp16_;
					const gchar* _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					const gchar* _tmp20_;
#line 249 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp14_ = _result_;
#line 249 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp15_ = line;
#line 249 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					g_string_append_printf (_tmp14_, "%s\n", _tmp15_);
#line 250 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp16_ = _result_;
#line 250 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp17_ = line;
#line 250 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp18_ = strlen (_tmp17_);
#line 250 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp19_ = _tmp18_;
#line 250 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					g_string_erase (_tmp16_, (gssize) 0, (gssize) (_tmp19_ + 1));
#line 251 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					_tmp20_ = line;
#line 251 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
					if (string_contains (_tmp20_, end)) {
#line 252 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						_g_free0 (line);
#line 252 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
						break;
#line 2375 "key-data.c"
					}
				}
#line 238 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
				_g_free0 (line);
#line 2380 "key-data.c"
			}
		}
	}
#line 256 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp21_ = _result_;
#line 256 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp22_ = _tmp21_->str;
#line 256 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 256 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp23_;
#line 256 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 256 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_string_free0 (_result_);
#line 256 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 2398 "key-data.c"
}


SeahorseSshSecData*
seahorse_ssh_sec_data_construct (GType object_type)
{
	SeahorseSshSecData * self = NULL;
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	self = (SeahorseSshSecData*) g_object_new (object_type, NULL);
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return self;
#line 2410 "key-data.c"
}


SeahorseSshSecData*
seahorse_ssh_sec_data_new (void)
{
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return seahorse_ssh_sec_data_construct (SEAHORSE_SSH_TYPE_SEC_DATA);
#line 2419 "key-data.c"
}


const gchar*
seahorse_ssh_sec_data_get_rawdata (SeahorseSshSecData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_rawdata;
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 2436 "key-data.c"
}


void
seahorse_ssh_sec_data_set_rawdata (SeahorseSshSecData* self,
                                   const gchar* value)
{
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_strcmp0 (value, seahorse_ssh_sec_data_get_rawdata (self)) != 0) {
#line 2448 "key-data.c"
		gchar* _tmp0_;
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (self->priv->_rawdata);
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_rawdata = _tmp0_;
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY]);
#line 2458 "key-data.c"
	}
}


const gchar*
seahorse_ssh_sec_data_get_comment (SeahorseSshSecData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_comment;
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 2476 "key-data.c"
}


void
seahorse_ssh_sec_data_set_comment (SeahorseSshSecData* self,
                                   const gchar* value)
{
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (g_strcmp0 (value, seahorse_ssh_sec_data_get_comment (self)) != 0) {
#line 2488 "key-data.c"
		gchar* _tmp0_;
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		_g_free0 (self->priv->_comment);
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_comment = _tmp0_;
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY]);
#line 2498 "key-data.c"
	}
}


SeahorseSshAlgorithm
seahorse_ssh_sec_data_get_algo (SeahorseSshSecData* self)
{
	SeahorseSshAlgorithm result;
	SeahorseSshAlgorithm _tmp0_;
#line 195 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 195 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_tmp0_ = self->priv->_algo;
#line 195 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	result = _tmp0_;
#line 195 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	return result;
#line 2516 "key-data.c"
}


void
seahorse_ssh_sec_data_set_algo (SeahorseSshSecData* self,
                                SeahorseSshAlgorithm value)
{
#line 195 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 195 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	if (seahorse_ssh_sec_data_get_algo (self) != value) {
#line 195 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		self->priv->_algo = value;
#line 195 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY]);
#line 2532 "key-data.c"
	}
}


static void
seahorse_ssh_sec_data_class_init (SeahorseSshSecDataClass * klass)
{
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	seahorse_ssh_sec_data_parent_class = g_type_class_peek_parent (klass);
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_type_class_add_private (klass, sizeof (SeahorseSshSecDataPrivate));
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_ssh_sec_data_get_property;
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_ssh_sec_data_set_property;
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_sec_data_finalize;
#line 2550 "key-data.c"
	/**
	     * Everything excluding the comment
	     */
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY] = g_param_spec_string ("rawdata", "rawdata", "rawdata", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY] = g_param_spec_enum ("algo", "algo", "algo", SEAHORSE_SSH_TYPE_ALGORITHM, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2560 "key-data.c"
}


static void
seahorse_ssh_sec_data_instance_init (SeahorseSshSecData * self)
{
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	self->priv = SEAHORSE_SSH_SEC_DATA_GET_PRIVATE (self);
#line 2569 "key-data.c"
}


static void
seahorse_ssh_sec_data_finalize (GObject * obj)
{
	SeahorseSshSecData * self;
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecData);
#line 191 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (self->priv->_rawdata);
#line 193 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	_g_free0 (self->priv->_comment);
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	G_OBJECT_CLASS (seahorse_ssh_sec_data_parent_class)->finalize (obj);
#line 2585 "key-data.c"
}


/**
 * Represents the data in a private key.
 */
GType
seahorse_ssh_sec_data_get_type (void)
{
	static volatile gsize seahorse_ssh_sec_data_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_ssh_sec_data_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshSecDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_sec_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshSecData), 0, (GInstanceInitFunc) seahorse_ssh_sec_data_instance_init, NULL };
		GType seahorse_ssh_sec_data_type_id;
		seahorse_ssh_sec_data_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseSshSecData", &g_define_type_info, 0);
		g_once_init_leave (&seahorse_ssh_sec_data_type_id__volatile, seahorse_ssh_sec_data_type_id);
	}
	return seahorse_ssh_sec_data_type_id__volatile;
}


static void
_vala_seahorse_ssh_sec_data_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	SeahorseSshSecData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecData);
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	switch (property_id) {
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY:
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_sec_data_get_rawdata (self));
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY:
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_sec_data_get_comment (self));
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY:
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		g_value_set_enum (value, seahorse_ssh_sec_data_get_algo (self));
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 2634 "key-data.c"
		default:
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 2640 "key-data.c"
	}
}


static void
_vala_seahorse_ssh_sec_data_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	SeahorseSshSecData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecData);
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
	switch (property_id) {
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY:
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_sec_data_set_rawdata (self, g_value_get_string (value));
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY:
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_sec_data_set_comment (self, g_value_get_string (value));
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY:
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		seahorse_ssh_sec_data_set_algo (self, g_value_get_enum (value));
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 2673 "key-data.c"
		default:
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 183 "/builddir/build/BUILD/seahorse-3.32.2/ssh/key-data.vala"
		break;
#line 2679 "key-data.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



